<?php
// get children IDs and names given their parent

require_once('../connection.php');

$GS = array();
$global_settings_query = mysqli_query($con, "SELECT * FROM `global_settings`");
while ($row = mysqli_fetch_array($global_settings_query))
	$GS[$row["name"]] = $row["value"];
		
if (isset($_GET["type"])) $type = $_GET["type"];
if (isset($_GET["parent"])) $parent = $_GET["parent"];

$children = array();

$output = '';

if ($type == 'geo') 
{
	// select all geographical elements satisfying conditions
	$geo_query = mysqli_query($con, "SELECT * FROM `geographical_structure` WHERE `level` <= ".$GS["max_geography_level_allowed"]." ORDER BY `level` ASC, `name` ASC");
	$geo_table = array();
	
	while ($row = mysqli_fetch_array($geo_query))
	{
		// if parent of current row is $parent, add to output
		if ($row["parent_ID"] === $parent)
			$output .= $row["ID"]. '|' . $row["name"] . '||';
	}
		
}

if ($type == 'hie') 
{
	// select all geographical elements satisfying conditions
	$hie_query = mysqli_query($con, "SELECT * FROM `hierarchical_structure` WHERE `level` <= ".$GS["max_hierarchy_level_allowed"]." ORDER BY `level` ASC, `name` ASC");
	$hie_table = array();

	while ($row = mysqli_fetch_array($hie_query))
	{
		// if parent of current row is $parent, add to output
		if ($row["parent_ID"] === $parent)
			$output .= $row["ID"]. '|' . $row["name"] . '||';
	}
}

if ($type == 'entity')
{
	$parts = explode("-", $parent);
	$geo = $parts[0];
	$hie = $parts[1];
	
	// select all entities with given geographical and hierarchical properties ("parent")
	$entities_query = mysqli_query($con, "SELECT * FROM `entities` WHERE `geography` = '".$geo."' AND `hierarchy` = '".$hie."' AND `visibility` = 1 ORDER BY `name` ASC;");
	while ($row = mysqli_fetch_array($entities_query))
		// add to output
		$output .= $row["ID"].'|'.$row["name"].($row["sub_name"]?' '.$row["sub_name"]:"")."||";
}

if ($parent === '')
{
	$parent_string = "`parent_ID` IS NULL";
}
else
{
	$parent_string = "`parent_ID` = '".$parent."'";
}

if ($type == 'data')
{
	$output = '';
	// output property (if parent has data) of the parent itself
	$element_query = mysqli_query($con, "SELECT * FROM `data_structure` WHERE `level` <= ".$GS["max_data_level_allowed"]." AND `ID` = '".$parent."' AND `visibility` = 1 ORDER BY `order` ASC");
	$row = mysqli_fetch_array($element_query);
	$output .= $row["has_data"] . "||";

	// select child data columns given their parent data column
	$children_query = mysqli_query($con, "SELECT * FROM `data_structure` WHERE `level` <= ".$GS["max_data_level_allowed"]." AND ".$parent_string." AND `visibility` = 1 ORDER BY `order` ASC");
	while ($row = mysqli_fetch_array($children_query))
		// output them
		$output .= $row["ID"] . '|' . $row["name"] . "||";
}

if ($type == 'indicators')
{
	$output = '';

	// output property (if parent has data) of the parent itself
	$element_query = mysqli_query($con, "SELECT * FROM `indicators_structure` WHERE `level` <= ".$GS["max_indicator_level_allowed"]." AND `ID` = '".$parent."' AND `visibility` = 1 ORDER BY `order` ASC");
	$row = mysqli_fetch_array($element_query);
	$output .= $row["has_data"] . "||";

	// select child data columns given their parent data column
	$children_query = mysqli_query($con, "SELECT * FROM `indicators_structure` WHERE `level` <= ".$GS["max_indicator_level_allowed"]." AND ".$parent_string." AND `visibility` = 1 ORDER BY `order` ASC");
	while ($row = mysqli_fetch_array($children_query))
		// output them
		$output .= $row["ID"] . '|' . $row["name"] . "||";
}

if ($type == 'ratings')
{
	$output = '';

	// output property (if parent has data) of the parent itself
	$element_query = mysqli_query($con, "SELECT * FROM `ratings_structure` WHERE `level` <= ".$GS["max_rating_level_allowed"]." AND `ID` = '".$parent."' AND `visibility` = 1 ORDER BY `order` ASC");
	$row = mysqli_fetch_array($element_query);
	$output .= $row["has_data"] . "||";

	// select child data columns given their parent data column
	$children_query = mysqli_query($con, "SELECT * FROM `ratings_structure` WHERE `level` <= ".$GS["max_rating_level_allowed"]." AND ".$parent_string." AND `visibility` = 1 ORDER BY `order` ASC");
	while ($row = mysqli_fetch_array($children_query))
		// output them
		$output .= $row["ID"] . '|' . $row["name"] . "||";
}

if ($output === '' || $output === '0||' || $output === '1||')
	echo '#~';
else
	echo substr($output, 0, -2);
	
mysqli_close($con);

?>