<?php

require_once('../connection.php');
require_once('../preload.php');
require_once('../tables.php');
require_once('../support.php');
require_once('../format.php');
require_once('../taxonomy.php');

if (isset($_GET["dt"])) $dt_string = $_GET["dt"]; // type (data, indicator, rating) and ID of number that will be drawn, format [T]-[ID], [T] = 'd', 'i' or 'r'
if (isset($_GET["o"])) $object_string = $_GET["o"]; // list of objects numbers will be drawn for
	
$short_dt = substr($dt_string, 0, 1);
if ($short_dt == 'r') $datatype = 'ratings';
if ($short_dt == 'i') $datatype = 'indicators';
if ($short_dt == 'd') $datatype = 'data';
$value_ID = substr($dt_string, 2);

$objects = explode(',', $object_string);

$oldest_year = $GS["oldest_year"];
$newest_year = $GS["newest_year"];

$output = '';

// find exact datatype of selected row ID
$structure_dt_query_string = "SELECT `datatype` FROM `".$datatype."_structure` WHERE `ID` = '".$value_ID."'";
$structure_dt_query = mysqli_query($con, $structure_dt_query_string);
$structure_dt_row = mysqli_fetch_array($structure_dt_query);
$structure_dt = $structure_dt_row["datatype"];
$structure_dt = str_replace("n", "", str_replace(")", "", str_replace("(", "", $structure_dt)));
$params = explode(",", $structure_dt);
// extract multiplier from datatype - only multiplier affects numbers entering chart
if (count($params) == 3) $multiplier = $params[0]; else $multiplier = 1;

foreach ($objects as $object)
{
	// constructing query to fetch data
	$geo_level = get_geo_level($object);
	$hie_level = get_hie_level($object);
		
	$geo = get_geo($object);
	$hie = get_hie($object);
	
	$geo_from_bottom = $max_geo_level - $geo_level;	
	$hie_from_bottom = $max_hie_level - $hie_level;
	
	$is_entity = is_entity($object);
	
	if ($max_hie_level >= $GS["max_hierarchy_level_allowed"] || $max_geo_level >= $GS["max_geography_level_allowed"])
		$object = $geo.'-'.$hie;
	
	$query_string = 
	"SELECT 
	`".$datatype."`.`year` AS `year`,";
	
	// what to select
	if ($datatype == 'data') $query_string .= "	SUM(`data`.`value`) AS `value` ";
	if ($datatype == 'indicators') $query_string .=  " SUM(`indicators`.`value` * `indicators`.`weight`)/SUM(`indicators`.`weight`) AS `value` ";
	if ($datatype == 'ratings') $query_string .= " SUM(`ratings`.`value` * `ratings`.`weight`)/SUM(`ratings`.`weight`) AS `value` ";
	
	$query_string .= "
	FROM `".$datatype."` LEFT JOIN `entities` ON `".$datatype."`.`entity` = `entities`.`ID`
	LEFT JOIN `".$datatype."_structure` ON `".$datatype."`.`type` = `".$datatype."_structure`.`ID`
	LEFT JOIN `geographical_structure` AS `g0` ON `entities`.`geography` = `g0`.`ID`";
	
	// geographical and hierarchical criteria might be on any level - to iterate thgough all necessary levels (because table 'entities' stores only information about the lowest level, not about the whole path), table must be joined with itself, maybe even multiple times (based on number of levels)
	for ($i = 1; $i <= $geo_from_bottom; $i++)
		$query_string .= " LEFT JOIN `geographical_structure` AS `g".$i."` ON `g".($i-1)."`.`parent_ID` = `g".$i."`.`ID`";
	
	$query_string .= " LEFT JOIN `hierarchical_structure` AS `h0` ON `entities`.`hierarchy` = `h0`.`ID`";
	
	for ($i = 1; $i <= $hie_from_bottom; $i++)
		$query_string .= " LEFT JOIN `hierarchical_structure` AS `h".$i."` ON `h".($i-1)."`.`parent_ID` = `h".$i."`.`ID`";
	
	// basic criteria
	$query_string .= " WHERE 
	`".$datatype."`.`visibility` = 1
	AND `".$datatype."`.`value` IS NOT NULL
	AND `".$datatype."`.`year` >= ".$GS["oldest_year"]."
	AND `".$datatype."`.`year` <= ".$GS["newest_year"]."
	AND `".$datatype."`.`type` = '".$value_ID."'
	AND LEFT(`".$datatype."_structure`.`datatype`, 1) = 'n'";
	
	// geography and hierarchy criteria (or specific entity)
	if ($is_entity)
		$query_string .= " AND `".$datatype."`.`entity` = '".$object."'";
	else
		$query_string .= "
	AND `g".$geo_from_bottom."`.`ID` = '".$geo."'
	AND `h".$hie_from_bottom."`.`ID` = '".$hie."'";
	
	// if the object is not entity, data must be aggregated	
	$query_string .= " GROUP BY `".$datatype."`.`year` ORDER BY `".$datatype."`.`year` ASC";
	
	$query = mysqli_query($con, $query_string);

	// echo output that will be parsed by JavaScript function
	// write first 'n/a' values
	$row = mysqli_fetch_array($query);
	if ($row["year"] > $GS["oldest_year"])
		for ($i=$GS["oldest_year"]; $i<$row["year"]; $i++)
			$output .= $i.':n/a;';
			
	// write next, 'real' values
	$output .= $row["year"].':'.($multiplier*$row["value"]).';';
	while ($row = mysqli_fetch_array($query))
		$output .= $row["year"].':'.($multiplier*$row["value"]).';';
	$output = substr($output, 0, -1);
	$output .= '#';
}

$output = substr($output, 0, -1);
echo $output;

mysqli_close($con);

?>