<?php

// function for displaying left pane in "rankings" page - with selected columns, geography and hierarchy criteria and options to change them
function draw_selection($values_string, $criteria_string, $years_string, $display_string)
{
	global $T, $GS, $data_specs, $indicators_specs, $ratings_specs, $geo_table, $hie_table;
	
	$values = explode(",", $values_string); // columns
	$criteria_parts = explode("-", $criteria_string);
	$geos = explode(",", $criteria_parts[0]); // geography criteria
	$hies = explode(",", $criteria_parts[1]); // hierarchy criteria
	$display_parts = explode(",", $display_string);
	$new_display_string = $display_parts[0].','.$display_parts[1].',1-'.$GS["default_ranking_rows"]; // when displaying new ranking (with different set of columns, geography and hierarchy criteria), start from the first page

	// columns selection
	echo '<div class="sel-top">';
	echo '<h4>'.$T["columns"].'</h4>';
	echo '<div class="sel-content">';

	foreach ($values as $value) // for each selected column
	{
		$character = substr($value, 0, 1);
		$ID = substr($value, 1);
		if ($character == 'd') $text = $data_specs[$ID]["short_name"];
		if ($character == 'i') $text = $indicators_specs[$ID]["short_name"];
		if ($character == 'r') $text = $ratings_specs[$ID]["short_name"];
		if ($text)
			// display selected columns; clicking on them will remove them from column list and display new ranking
			echo '<a class="selected" href="/rankings/'.remove_from_list($values_string, $value).'/'.$criteria_string.'/'.$years_string.'/'.$new_display_string.'"><span>&nbsp;</span>'.$text.'</a>';
	}

	echo '<div class="clear"></div>';
	echo '</div>';
	// click will display dialog with selection of new columns
	echo '<a id="column-sel-trigger" class="button b-normal b-gray" onclick="hide(\'geo-sel\'); hide(\'hie-sel\'); toggleSelWindow(\'column-sel\', \'column-sel-trigger\');">'.$T["add_new"].'</a>';
	echo '</div>';

	// geography criteria selection
	echo '<div class="sel-middle">';
	echo '<h4>'.$T["geography"].'</h4>';
	echo '<div class="sel-content">';

	foreach ($geos as $geo) // for each seleted geography criterion
	{
		if ($geo_table[$geo]["name"])
			// display selected criteria; clicking on them will remove them from criteria list and display new ranking
			echo '<a class="selected" href="/rankings/'.$values_string.'/'.remove_from_list($criteria_parts[0], $geo).'-'.$criteria_parts[1].'/'.$years_string.'/'.$new_display_string.'"><span>&nbsp;</span>'.$geo_table[$geo]["name"].'</a>';
	}

	echo '<div class="clear"></div>';
	echo '</div>';
	// click will display dialog with selection of new geography criteria
	echo '<a id="geo-sel-trigger" class="button b-normal b-gray" onclick="hide(\'column-sel\'); hide(\'hie-sel\'); toggleSelWindow(\'geo-sel\', \'geo-sel-trigger\', \''.$values_string.'\', \''.$criteria_string.'\', \''.$years_string.'\', \''.$new_display_string.'\');">'.$T["add_new"].'</a>';
	echo '</div>';

	// hierarchy criteria selection
	echo '<div class="sel-bottom">';
	echo '<h4>'.$T["hierarchy"].'</h4>';
	echo '<div class="sel-content">';

	foreach ($hies as $hie) // for each seleted hierarchy criterion
	{
		if ($hie_table[$hie]["name"])
			// display selected criteria; clicking on them will remove them from criteria list and display new ranking
			echo '<a class="selected" href="/rankings/'.$values_string.'/'.$criteria_parts[0].'-'.remove_from_list($criteria_parts[1], $hie).'/'.$years_string.'/'.$new_display_string.'"><span>&nbsp;</span>'.$hie_table[$hie]["name"].'</a>';
	}

	echo '<div class="clear"></div>';
	echo '</div>';
	// click will display dialog with selection of new hierarchy criteria
	echo '<a id="hie-sel-trigger" class="button b-normal b-gray" onclick="hide(\'geo-sel\'); hide(\'column-sel\'); toggleSelWindow(\'hie-sel\', \'hie-sel-trigger\', \''.$values_string.'\', \''.$criteria_string.'\', \''.$years_string.'\', \''.$new_display_string.'\');">'.$T["add_new"].'</a>';
	echo '</div>';

	echo '<div class="clear"></div>';
}

// display window with selection of columns for ranking
function draw_column_selection($values_string, $criteria_string, $years_string, $display_string)
{
	global $T, $GS, $data_specs, $indicators_specs, $ratings_specs, $max_data_level, $max_indicators_level, $max_ratings_level;
	
	echo '<div id="column-sel" class="sel" style="display: none;">';
	
	if ($GS["rankings_list_columns"] == 1) // list all possible columns (data, indicators and ratings)
	{
		echo '<div class="sel-content">';
		
		for ($i = 0; $i < 3; $i++) // iterate through data, indicators and ratings
		{
			if ($i == 0) {$specs = $ratings_specs; $max_level = min($max_ratings_level, $GS["max_rating_level_allowed"]); $char = 'r';}
			if ($i == 1) {$specs = $indicators_specs; $max_level = min($max_indicators_level, $GS["max_indicator_level_allowed"]); $char = 'i';}
			if ($i == 2) {$specs = $data_specs; $max_level = min($max_data_level, $GS["max_data_level_allowed"]); $char = 'd';}
			
			if ($max_level >= 0) // at least one column of particular type should be displayed
			{			
				$l1c = 0;
				foreach ($specs as $ID => $row) // iterate through all possible columns
				{
					$level = min(4, $row["level"]);
					$class = "level-".$level.($level == $max_level?" level-max":"");
					$value = $char.$ID;
			
					// just styling results (aligning into row / column blocks) for better clarity
					if ($level == 0) 
					{
						$text_before = '<div class="clear"></div><div class="dl0">';
						$text_after = '<div class="clear"></div></div>';
					}
					elseif ($level == 1)
					{
						if ($l1c == 0) $text_before = '<div class="dl1"><div>'; else $text_before = '<div class="clear"></div></div><div class="dl1"><div>';
						$text_after = '<div class="clear"></div></div>';
						$l1c++;
					}
					else
					{
						$text_before = '';
						$text_after = '';
					}
					
					if ($level <= $max_level)
					{
						if ($row["has_data"]) // is a column with values, therefore can be added to or removed from column list
						{
							if (in_list($values_string, $value))
								echo $text_before.'<a class="selected '.$class.'" href="/rankings/'.remove_from_list($values_string, $value).'/'.$criteria_string.'/'.$years_string.'/'.$display_string.'"><span>&nbsp;</span>'.$row["name"].'</a>'.$text_after;
							else
								echo $text_before.'<a class="unselected '.$class.'" href="/rankings/'.add_to_list($values_string, $value).'/'.$criteria_string.'/'.$years_string.'/'.$display_string.'"><span>&nbsp;</span>'.$row["name"].'</a>'.$text_after;
						}
						else // is a column without values, therefore cannot be added to or removed from column list, server only for better navigation
						{
							echo $text_before.'<span class="name '.$class.'">'.$row["name"].'</span>'.$text_after;
						}
					}
				}
				if ($l1c > 0) echo '<div class="clear"></div></div>';
				echo '<div class="clear"></div>';
			}

			echo '</div>';
		}
	}
	else // do not list all possible columns, instead display dropdown menus, each representing one level of data / indicators / ratings structure
	{
		$max_level = max(min($max_ratings_level, $GS["max_rating_level_allowed"]), min($max_indicators_level, $GS["max_indicator_level_allowed"]), min($max_data_level, $GS["max_data_level_allowed"]));
		
		echo '<div class="cnw-element-wrapper">';
		// iterate through all levels of data / indicators / ratings
		// level == -1 represents selecting type of values (data, indicators or ratings)
		// level >= 0 represents selecting of actual column
		for ($i = -1; $i <= $max_level; $i++)
		{
			if ($i >= 0) $display = "style=' display: none'"; else $display = "";
			if ($i == -1) $text = $T["type"];
			if ($i == 0) $text = $T["column"];
			if ($i > 0) $text = '&nbsp;';
			echo '<div id="col-div-'.$i.'"'.$display.'><span>'.$text.'</span>';
			// dropdown menu
			echo '<select class="cn-select" id="col-select-'.$i.'" name="col-select-'.$i.'" onchange="doColSelect('.$i.', \''.$values_string.'\', \''.$criteria_string.'\', \''.$years_string.'\', \''.$display_string.'\')">';
			if ($i == -1)
			{
				// display options for selection data, indicators or ratings
				echo '<option value = "#~">('.$T["select_type"].')</option>';
				if ($GS["max_rating_level_allowed"] >= 0) echo '<option value = "ratings">'.$T["ratings"].'</option>';
				if ($GS["max_indicator_level_allowed"] >= 0) echo '<option value = "indicators">'.$T["indicators"].'</option>';
				if ($GS["max_data_level_allowed"] >= 0) echo '<option value = "data">'.$T["data"].'</option>';
			}
			else
				// display only "select column" option, since we do not already know content (other options) - it depends on selection in previous select
				echo '<option value = "#~">('.$T["select_column"].')</option>';
			echo '</select>';
			if ($i >= 0)
				echo '<a class="button b-normal b-yellow-deactivated" id="col-cnb-add-'.$i.'">'.$T["add"].'</a>'; // button for adding selected column into ranking
			echo '<span id="selectcolumntext" class="dummy">'.$T["select_column"].'</span>'; // dummy span, used for javascript
			echo '</div>';
		}
		echo '</div>';
	}
		
	echo '<a class="button b-normal b-gray" onclick="hide(\'column-sel\');">'.$T["close"].'</a>'; // hide window
	echo '</div>';
}

// recursive function for drawing individual levels of geography criteria for ranking
function draw_geo_selection_tree($parent, $values_string, $geos_string, $hies_string, $years_string, $display_string, $max_level)
{
	global $l1c, $T;
	
	$ID = $parent["ID"];
	$level = min(4, $parent["level"]); // styling only top four levels of geographical structure; levels >= 5 whill have the same styling as level = 4
	$class = "level-".$level.($level == $max_level?" level-max":"");

	// just styling results (aligning into row / column blocks) for better clarity
	if ($level == 0) 
	{
		$text_before = '<div class="dl0">';
		$text_after = '<div class="clear"></div></div>';
	}
	elseif ($level == 1)
	{
		if ($l1c == 0) $text_before = '<div class="dl1">'; else $text_before = '<div class="clear"></div></div><div class="dl1">';
		$text_after = '';
		$l1c++;
	}
	else
	{
		$text_before = '';
		$text_after = '';
	}
	
	if ($level == 0) $text = $T["all"]; else $text = $parent["name"];

	if (in_list($geos_string, $ID)) // if parent geography is in list of already selected geography criteria
		// clicking button will remove parent from the list of geography criteria
		echo $text_before.'<a class="selected '.$class.'" href="/rankings/'.$values_string.'/'.remove_from_list($geos_string, $ID).'-'.$hies_string.'/'.$years_string.'/'.$display_string.'"><span>&nbsp;</span>'.$text.'</a>'.$text_after;
	else
		// clicking button will add parent to the list of geography criteria
		echo $text_before.'<a class="unselected '.$class.'" href="/rankings/'.$values_string.'/'.add_to_list($geos_string, $ID).'-'.$hies_string.'/'.$years_string.'/'.$display_string.'"><span>&nbsp;</span>'.$text.'</a>'.$text_after;
		
	if ($level < $max_level) // dig deeper into tree
	{
		$children = get_geo_children($ID); // find all children
		foreach ($children as $child_ID => $child_data) // run function again for all children
			draw_geo_selection_tree($child_data, $values_string, $geos_string, $hies_string, $years_string, $display_string, $max_level);
	}
}

// "master" function for enabling selection of geography criteria for ranking
function draw_geo_selection($values_string, $criteria_string, $years_string, $display_string)
{
	global $T, $GS, $geo_table, $max_geo_level, $l1c;
	
	echo '<div id="geo-sel" class="sel" style="display: none;">';
	
	$max_level = min($max_geo_level, $GS["max_ranking_geography_level_allowed"]);
	$all_geos = reset(get_geos('0')); // 'master' geographical structure element

	$criteria_parts = explode("-", $criteria_string);
	$geos_string = $criteria_parts[0];
	$hies_string = $criteria_parts[1];

	if ($GS["rankings_list_geography"] == 1) // list all geography structure elements
	{
		$l1c = 0; // number of level 1 elements

		echo '<div class="sel-content">';
		
		// recursive function for drawing geographical structure tree; start with level == 0, walk through tree
		draw_geo_selection_tree($all_geos, $values_string, $geos_string, $hies_string, $years_string, $display_string, $max_level);		
		if ($l1c > 0) echo '<div class="clear"></div></div>';
		echo '<div class="clear"></div>';
		
		echo '</div>';
		echo '<a class="button b-normal b-gray" onclick="hide(\'geo-sel\');">'.$T["close"].'</a>'; // hide window
	}
	else // do not list all possible geography structure elements, instead display dropdown menus, each representing one level of geographical structure
	{
		global $geo_list_table;
		
		$geos = get_geos('1'); // get all geographical structure elements with level = 1
		echo '<div class="cnw-element-wrapper">';
		for ($i = 1; $i <= $max_level; $i++)
		{
			if ($i > 1) $display = "style=' display: none'"; else $display = ""; // show dropdown menu only for the first level
			echo '<div id="geo-div-'.$i.'"'.$display.'><span>'.$geo_list_table[$i]["name"].'</span>';
			// dropdown menu
			echo '<select class="cn-select" id="geo-select-'.$i.'" name="geo-select-'.$i.'" onchange="doRankSelect(\'geo\', '.$i.', '.$max_level.', \''.$values_string.'\', \''.$criteria_string.'\', \''.$years_string.'\', \''.$display_string.'\')">';
			if ($i == 1)
			{
				echo '<option value = "'.$all_geos["ID"].'">('.$T["all"].')</option>'; // displays option with 'master' geographical structure elements
				foreach ($geos as $geo) // displays options with all geographical structure elements with level = 1
					echo '<option value = "'.$geo["ID"].'">'.$geo["name"].'</option>';
			}
			else
				// display only "all" option, since we do not already know content (other options) - it depends on selection in previous select
				echo '<option value = "#~">('.$T["all"].')</option>';
			echo '</select>';
			echo '</div>';
		}
		echo '</div>';
			
		echo '<div class="cnw-buttons">';
		echo '<a class="fleft button b-normal b-gray" onclick="hide(\'geo-sel\')">'.$T["close"].'</a>'; // hide window
		echo '<a class="fright button b-normal b-yellow" id="geo-cnb-add">'.$T["add"].'</a>'; // add selected geographical structure element to list of geography criteria
		echo '<span id="alltext" class="dummy">'.$T["all"].'</span>'; // dummy span, used for javascript
		echo '<div class="clear"></div>';
		echo '</div>';
	}
	
	echo '</div>';
}

// recursive function for drawing individual levels of hierarchy criteria for ranking
function draw_hie_selection_tree($parent, $values_string, $geos_string, $hies_string, $years_string, $display_string, $max_level)
{
	global $T, $l1c;

	$ID = $parent["ID"];
	$level = min(4, $parent["level"]); // styling only top four levels of hierarchical structure; levels >= 5 whill have the same styling as level = 4
	$class = "level-".$level.($level == $max_level?" level-max":"");

	// just styling results (aligning into row / column blocks) for better clarity
	if ($level == 0) 
	{
		$text_before = '<div class="dl0">';
		$text_after = '<div class="clear"></div></div>';
	}
	elseif ($level == 1)
	{
		if ($l1c == 0) $text_before = '<div class="dl1">'; else $text_before = '<div class="clear"></div></div><div class="dl1">';
		$text_after = '';
		$l1c++;
	}
	else
	{
		$text_before = '';
		$text_after = '';
	}

	if ($level == 0) $text = $T["all"]; else $text = $parent["name"];

	if (in_list($hies_string, $ID)) // if parent hierarchy is in list of already selected hierarchy criteria
		// clicking button will remove parent from the list of hierarchy criteria
		echo $text_before.'<a class="selected '.$class.'" href="/rankings/'.$values_string.'/'.$geos_string.'-'.remove_from_list($hies_string, $ID).'/'.$years_string.'/'.$display_string.'"><span>&nbsp;</span>'.$text.'</a>'.$text_after;
	else
		// clicking button will add parent to the list of hierarchy criteria
		echo $text_before.'<a class="unselected '.$class.'" href="/rankings/'.$values_string.'/'.$geos_string.'-'.add_to_list($hies_string, $ID).'/'.$years_string.'/'.$display_string.'"><span>&nbsp;</span>'.$text.'</a>'.$text_after;
		
	if ($level < $max_level) // dig deeper into tree
	{
		$children = get_hie_children($ID); // find all children
		foreach ($children as $child_ID => $child_data) // run function again for all children
			draw_hie_selection_tree($child_data, $values_string, $geos_string, $hies_string, $years_string, $display_string, $max_level);
	}
}

// "master" function for enabling selection of hierarchy criteria for ranking
function draw_hie_selection($values_string, $criteria_string, $years_string, $display_string)
{
	global $T, $GS, $hie_table, $max_hie_level, $l1c;
	
	echo '<div id="hie-sel" class="sel" style="display: none;">';
	
	$max_level = min($max_hie_level, $GS["max_ranking_hierarchy_level_allowed"]);
	$all_hies = reset(get_hies('0')); // 'master' hierarchical structure element

	$criteria_parts = explode("-", $criteria_string);
	$geos_string = $criteria_parts[0];
	$hies_string = $criteria_parts[1];

	if ($GS["rankings_list_hierarchy"] == 1) // list all hierarchical structure elements
	{
		$l1c = 0; // number of level 1 elements

		echo '<div class="sel-content">';
		
		// recursive function for drawing hierarchical structure tree; start with level = 0, walk through tree
		draw_hie_selection_tree($all_hies, $values_string, $geos_string, $hies_string, $years_string, $display_string, $max_level);		
		if ($l1c > 0) echo '<div class="clear"></div></div>';
		echo '<div class="clear"></div>';
		
		echo '</div>';
		echo '<a class="button b-normal b-gray" onclick="hide(\'hie-sel\');">'.$T["close"].'</a>';
	}
	else // do not list all possible hierarchical structure elements, instead display dropdown menus, each representing one level of hierarchical structure
	{
		global $hie_list_table;
		
		$hies = get_hies('1'); // get all hierarchical structure elements with level = 1
		echo '<div class="cnw-element-wrapper">';
		for ($i = 1; $i <= $max_level; $i++)
		{
			if ($i > 1) $display = "style=' display: none'"; else $display = ""; // show dropdown menu only for the first level
			echo '<div id="hie-div-'.$i.'"'.$display.'><span>'.$hie_list_table[$i]["name"].'</span>';
			// dropdown menu
			echo '<select class="cn-select" id="hie-select-'.$i.'" name="hie-select-'.$i.'" onchange="doRankSelect(\'hie\', '.$i.', '.$max_level.', \''.$values_string.'\', \''.$criteria_string.'\', \''.$years_string.'\', \''.$display_string.'\')">';
			if ($i == 1)
			{
				echo '<option value = "'.$all_hies["ID"].'">('.$T["all"].')</option>'; // displays option with 'master' hierarchical structure elements
				foreach ($hies as $hie) // displays options with all hierarchical structure elements with level = 1
					echo '<option value = "'.$hie["ID"].'">'.$hie["name"].'</option>';
			}
			else
				// display only "all" option, since we do not already know content (other options) - it depends on selection in previous select
				echo '<option value = "#~">('.$T["all"].')</option>';
			echo '</select>';
			echo '</div>';
		}
		echo '</div>';
			
		echo '<div class="cnw-buttons">';
		echo '<a class="fleft button b-normal b-gray" onclick="hide(\'hie-sel\')">'.$T["close"].'</a>'; // hide window
		echo '<a class="fright button b-normal b-yellow" id="hie-cnb-add">'.$T["add"].'</a>'; // add selected hierarchical structure element to list of hierarchy criteria
		echo '<span id="alltext" class="dummy">'.$T["all"].'</span>'; // dummy span, used for javascript
		echo '<div class="clear"></div>';
		echo '</div>';
	}

	echo '</div>';
}

// function for displaying window with adding / changing elements in "comparison" page
function draw_cn_window()
{
	global $T, $max_geo_level, $max_hie_level, $geo_list_table, $hie_list_table, $objects_string, $years;
	
	// 'master' geographical and hierarchical structure element
	$all_geos = reset(get_geos('0'));
	$geos = get_geos('1');
	$all_hies = reset(get_hies('0'));
	$hies = get_hies('1');
		
	echo '<div id="cn-window" style="display: none;">';
	
	if ($T["cnw_disclaimer"]) // how to navigate through dropdown menus
		echo '<div class="cnw-element-wrapper"><p class="info-area">'.$T["cnw_disclaimer"].'</p></div>';

	// dropdown menus for geographical structure
	echo '<div class="cnw-element-wrapper">';
	for ($i = 1; $i <= $max_geo_level; $i++)
	{
		if ($i > 1) $display = "style=' display: none'"; else $display = ""; // show dropdown menu only for the first level
		echo '<div id="geo-div-'.$i.'"'.$display.'><span>'.$geo_list_table[$i]["name"].'</span>';
		// dropdown menu
		echo '<select class="cn-select" id="geo-select-'.$i.'" name="geo-select-'.$i.'" onchange="doSelect(\'geo\', '.$i.', '.$max_geo_level.', \''.$objects_string.'\', \''.$years.'\')">';
		if ($i == 1)
		{
			echo '<option value = "'.$all_geos["ID"].'">('.$T["all"].')</option>'; // displays option with 'master' geographical structure elements
			foreach ($geos as $geo) // displays options with all geographical structure elements with level = 1
				echo '<option value = "'.$geo["ID"].'">'.$geo["name"].'</option>';
		}
		else
			// display only "all" option, since we do not already know content (other options) - it depends on selection in previous select
			echo '<option value = "#~">('.$T["all"].')</option>';
		echo '</select>';
		echo '</div>';
	}
	echo '</div>';
		
	// dropdown menus for hierarchical structure
	echo '<div class="cnw-element-wrapper">';
	for ($i = 1; $i <= $max_hie_level; $i++)
	{
		if ($i > 1) $display = "style=' display: none'"; else $display = ""; // show dropdown menu only for the first level
		echo '<div id="hie-div-'.$i.'"'.$display.'><span>'.$hie_list_table[$i]["name"].'</span>';
		// dropdown menu
		echo '<select class="cn-select" id="hie-select-'.$i.'" name="hie-select-'.$i.'" onchange="doSelect(\'hie\', '.$i.', '.$max_hie_level.', \''.$objects_string.'\', \''.$years.'\')">';
		if ($i == 1)
		{
			echo '<option value = "'.$all_hies["ID"].'">('.$T["all"].')</option>'; // displays option with 'master' hierarchical structure elements
			foreach ($hies as $hie) // displays options with all hierarchical structure elements with level = 1
				echo '<option value = "'.$hie["ID"].'">'.$hie["name"].'</option>';
		}
		else
			// display only "all" option, since we do not already know content (other options) - it depends on selection in previous select
			echo '<option value = "#~">('.$T["all"].')</option>';
		echo '</select>';
		echo '</div>';
	}
	echo '</div>';

	// dropdown menu for entity selection
	echo '<div class="cnw-element-wrapper" id="entity-div" style="display: none;">'; // hidden, since it will be visible only if geographical and hierarchical structure is selected
	echo '<div><span>'.$T["entity"].'</span>';
	// dropdown menu
	echo '<select class="cn-select" id="entity-select" name="entity-select" onchange="doSelect(\'entity\', 0, 0, \''.$objects_string.'\', \''.$years.'\')">';
	// display only "all" option, since we do not already know content (other options) - it depends on selection in previous selects
	echo '<option value = "#~">('.$T["all"].')</option>';
	echo '</select>';
	echo '</div>';
	echo '</div>';
	
	echo '<div class="cnw-buttons">';
	echo '<a class="fleft button b-normal b-gray" onclick="hide(\'cn-window\')">'.$T["close"].'</a>'; // hide window
	echo '<a class="fright button b-normal b-yellow" id="cnb-add">'.$T["add_to_comparison"].'</a>'; // add selected object (entity or aggregate) to list of compared objects
	echo '<span id="pos-dummy" class="dummy"></span>'; // dummy span, used for javascript
	echo '<div class="clear"></div>';
	echo '</div>';
	
	echo '</div>';
}

?>