<?php

// defining arrays with data from mysql tables that are used most often

// geographical structure - each 'row' represents one element from geographical structure
// associative array - key is element ID
$geo_query = mysqli_query($con, "SELECT * FROM `geographical_structure` WHERE `visibility` = 1 ORDER BY `level` ASC, `name` ASC");
$geo_table = array();
while ($row = mysqli_fetch_array($geo_query))
	$geo_table[$row["ID"]] = $row;
	
// geographical structure list - each 'row' represents one level of geographical structure
// associative array - key is geographical structure level
$geo_list_query = mysqli_query($con, "SELECT * FROM `geographical_structure_list` ORDER BY `level` ASC, `name` ASC");
$geo_list_table = array();
while ($row = mysqli_fetch_array($geo_list_query))
	$geo_list_table[$row["level"]] = $row;

// geographical tree - used for walking throuhg the tree - each 'row' represents one link in the tree
// associative array - key is child ID, value is parent ID 
$geo_tree = array();
foreach ($geo_table as $geo_row)
	$geo_tree[$geo_row["ID"]] = $geo_row["parent_ID"];

// hierarchical structure - each 'row' represents one element from hierarchical structure
// associative array - key is element ID
$hie_query = mysqli_query($con, "SELECT * FROM `hierarchical_structure` WHERE `visibility` = 1 ORDER BY `level` ASC, `name` ASC");
$hie_table = array();
while ($row = mysqli_fetch_array($hie_query))
	$hie_table[$row["ID"]] = $row;

// hierarchical structure list - each 'row' represents one level of hierarchical structure
// associative array - key is hierarchical structure level
$hie_list_query = mysqli_query($con, "SELECT * FROM `hierarchical_structure_list`");
$hie_list_table = array();
while ($row = mysqli_fetch_array($hie_list_query))
	$hie_list_table[$row["level"]] = $row;
 
// hierarchical tree - used for walking throuhg the tree - each 'row' represents one link in the tree
// associative array - key is child ID, value is parent ID 
$hie_tree = array();
foreach ($hie_table as $hie_row)
	$hie_tree[$hie_row["ID"]] = $hie_row["parent_ID"];

// data specification - used for formatting displayed data - each 'row' represents one data element
// associative array - key is data element ID, value is row from table with its specification
$data_specs_query = mysqli_query($con, "SELECT * FROM `data_structure` WHERE `visibility` = 1 ORDER BY `order` ASC");
$data_specs = array();
while ($row = mysqli_fetch_array($data_specs_query))
	$data_specs[$row["ID"]] = $row;
	
// indicators specification - used for formatting displayed indicators - each 'row' represents one indicator element
// associative array - key is indicator element ID, value is row from table with its specification
$indicators_specs_query = mysqli_query($con, "SELECT * FROM `indicators_structure` WHERE `visibility` = 1 ORDER BY `order` ASC");
$indicators_specs = array();
while ($row = mysqli_fetch_array($indicators_specs_query))
	$indicators_specs[$row["ID"]] = $row;
	
// ratings specification - used for formatting displayed ratings - each 'row' represents one rating element
// associative array - key is rating element ID, value is row from table with its specification
$ratings_specs_query = mysqli_query($con, "SELECT * FROM `ratings_structure` WHERE `visibility` = 1 ORDER BY `order` ASC");
$ratings_specs = array();
while ($row = mysqli_fetch_array($ratings_specs_query))
	$ratings_specs[$row["ID"]] = $row;

// views array - defining, which value (data, indicator, rating) is valid for which hierarchical elemenet	
$views_query = mysqli_query($con, "SELECT * FROM `views`");
$views = array();
while ($row = mysqli_fetch_array($views_query))
	$views[substr($row["type"], 0, 1).$row["value_type_ID"]][] = $row["hierarchy_ID"];

// maximum geography level
$max_geo_level_query = mysqli_query($con, "SELECT max(`level`) AS M FROM `geographical_structure_list`");
$max_geo_level_row = mysqli_fetch_array($max_geo_level_query);
$max_geo_level = min($max_geo_level_row["M"], $GS["max_geography_level_allowed"]);

// maximum hierarchy level	
$max_hie_level_query = mysqli_query($con, "SELECT max(`level`) AS M FROM `hierarchical_structure_list`");
$max_hie_level_row = mysqli_fetch_array($max_hie_level_query);
$max_hie_level = min($max_hie_level_row["M"], $GS["max_hierarchy_level_allowed"]);

// maximum data level	
$max_data_level_query = mysqli_query($con, "SELECT max(`level`) AS M FROM `data_structure`");
$max_data_level_row = mysqli_fetch_array($max_data_level_query);
$max_data_level = min($max_data_level_row["M"], $GS["max_data_level_allowed"]);

// maximum indicators level	
$max_indicators_level_query = mysqli_query($con, "SELECT max(`level`) AS M FROM `indicators_structure`");
$max_indicators_level_row = mysqli_fetch_array($max_indicators_level_query);
$max_indicators_level = min($max_indicators_level_row["M"], $GS["max_indicator_level_allowed"]);

// maximum ratings level	
$max_ratings_level_query = mysqli_query($con, "SELECT max(`level`) AS M FROM `ratings_structure`");
$max_ratings_level_row = mysqli_fetch_array($max_ratings_level_query);
$max_ratings_level = min($max_ratings_level_row["M"], $GS["max_rating_level_allowed"]);

?>