<?php

// draw breadcrumb
function draw_bread()
{
	// for current geo and hie (and therefore geo_bread, hie_bread, geo_bread_names, hie_bread_names)
	global $T, $GS, $hie_bread, $geo_bread, $geo_bread_names, $hie_bread_names, $geo, $hie, $years;
	
	echo '<div id="breadcrumb">';

	echo '<div id="bread-dim-names">';
		echo '<div>'.$T["bread_geography"].'</div>';
		echo '<div>'.$T["bread_hierarchy"].'</div>';
	echo '</div>';
	
	echo '<div id="bread-dims">';
		// geography breadcrumb
		echo '<div>';
			for ($i=0; $i<count($geo_bread); $i++)
				echo '<a href="/profile/'.$geo_bread[$i].'-'.$hie.'/'.$years.'">'. $geo_bread_names[$i].'</a>';
		echo '</div>';
		// hierarchy breadcrumb
		echo '<div>';	
			for ($i=0; $i<count($hie_bread); $i++)
				echo '<a href="/profile/'.$geo.'-'.$hie_bread[$i].'/'.$years.'">'.$hie_bread_names[$i].'</a>';		
		echo '</div>';		
	echo '</div>';
	
	echo '<div class="clear"></div>';
	
	echo '</div>';
}

// draw geography navigation in left navigation pane in "profiles" page
function draw_geo_navigation()
{
	global $T, $geo_list_table, $geo_tree, $geo_table, $max_geo_level, $GS, $is_entity, $geo_level, $geo_bread, $hie, $geo, $years, $geo_list_table;
	
	// if current object is entity, full level is equal to real geo level + 1
	$full_geo_level = $is_entity ? $geo_level + 1 : $geo_level;
	$full_geo_level = min($full_geo_level, $max_geo_level);
	
	// parent is needed for returning up one level
	if ($is_entity)
		$parent_geo = end($geo_bread);
	else
		$parent_geo = $geo_bread[count($geo_bread) - 2];

	echo '<div id="nav-geo">';
	
	// button for returning one level up
	if ($is_entity || $full_geo_level > 0)
	{
		echo '<div class="nav-button">';
		if ($is_entity)
			echo '<a class="button b-normal b-darkgray" href="/profile/'.$parent_geo.'-'.$hie.'/'.$years.'">&larr;&emsp;'.strtolower($T["back_to"]).' '.strtolower($T["entities"]).'</a>';
		else
			if ($full_geo_level > 0)
				echo '<a class="button b-normal b-darkgray" href="/profile/'.$parent_geo.'-'.$hie.'/'.$years.'">&larr;&emsp;'.strtolower($T["back_to"]).' '.strtolower($geo_list_table[$full_geo_level]["text_multi"]).'</a>';
		echo '</div>';
	}
		
	if ($full_geo_level == $max_geo_level) // current navigation level is bottom level
	{
		// therefore display entities, not actual geographical structure
		echo '<div class="nav-type">'.$T["entities"].'</div>';
		$entities = get_entities($geo, $hie);
		foreach ($entities as $ID => $data)
			echo '<a class="nav-row" href="/profile/'.$ID.'/'.$years.'">'.$data["short_name"].($data["sub_name"]?'<span>'.$data["sub_name"].'</span>':'').'</a>';
	}
	else
	{
		if ($geo_level < $max_geo_level) // current navigation level is not bottom level
			echo '<div class="nav-type">'.$geo_list_table[$geo_level+1]["text_multi"].'</div>'; // name for geographical structure elements that will be displayed
		$nodes = array_keys($geo_tree, $geo); // find IDs of all children of current $geo
		for ($i=0; $i<count($nodes); $i++) // display them
			echo '<a class="nav-row" href="/profile/'.$nodes[$i].'-'.$hie.'/'.$years.'">'.$geo_table[$nodes[$i]]["short_name"].'</a>';
	}

	echo '</div>';	
}

// draw geography navigation in left navigation pane in "profiles" page
function draw_hie_navigation()
{
	global $T, $hie_list_table, $hie_tree, $hie_table, $max_hie_level, $GS, $is_entity, $hie_level, $geo_bread, $hie_bread, $hie_bread_names, $hie, $geo, $years, $other_objects_string;
	
	// if current object is entity, full level is equal to real hie level + 1
	$full_hie_level = $is_entity ? $hie_level + 1 : $hie_level;
	$full_hie_level = min($full_hie_level, $max_hie_level);
	
	// parent is needed for returning up one level
	if ($is_entity)
		$parent_hie = end($hie_bread);
	else
		$parent_hie = $hie_bread[count($hie_bread) - 2];

	echo '<div id="nav-hie" style="display: none;">';
	
	// button for returning one level up
	if ($is_entity || $full_hie_level > 0)
	{
		echo '<div class="nav-button">';	
		if ($is_entity)
			echo '<a class="button b-normal b-darkgray" href="/profile/'.$geo.'-'.$parent_hie.$other_objects_string.'/'.$years.'">&larr;&emsp;'.strtolower($T["back_to"]).' '.strtolower($T["entities"]).'</a>';
		else
			if ($full_hie_level > 0)
				echo '<a class="button b-normal b-darkgray" href="/profile/'.$geo.'-'.$parent_hie.$other_objects_string.'/'.$years.'">&larr;&emsp;'.strtolower($T["back_to"]).' '.strtolower($hie_list_table[$full_hie_level]["text_multi"]).'</a>';
		echo '</div>';
	}
		
	if ($full_hie_level == $max_hie_level) // current navigation level is bottom level
	{
		// therefore display entities, not actual geographical structure
		echo '<div class="nav-type">'.end($hie_bread_names).'</div>';
		$entities = get_entities($geo, $hie);
		foreach ($entities as $ID => $data)
			echo '<a class="nav-row" href="/profile/'.$ID.$other_objects_string.'/'.$years.'">'.$data["short_name"].($data["sub_name"]?'<span>'.$data["sub_name"].'</span>':'').'</a>';
	}
	else
	{
		if ($hie_level < $max_hie_level) // current navigation level is not bottom level
			echo '<div class="nav-type">'.$hie_list_table[$hie_level+1]["text_multi"].'</div>'; // name for geographical structure elements that will be displayed
		$nodes = array_keys($hie_tree, $hie); // find IDs of all children of current $geo
		for ($i=0; $i<count($nodes); $i++) // display them
			echo '<a class="nav-row" href="/profile/'.$geo.'-'.$nodes[$i].$other_objects_string.'/'.$years.'">'.$hie_table[$nodes[$i]]["short_name"].'</a>';
	}

	echo '</div>';	
}

// draw wrapper for left navigation pane including navigation itself - both geographical and hierarchical
function draw_navigation()
{
	global $T;
	echo '<div id="nav-wrapper">';
	echo '<div id="nav">';
	echo '<div id="nav-tabs-wrapper">';
	echo '<ul><li id="li-nav-geo" onclick="switchNav(\'geo\')">'.$T["geography"].'</li><li id="li-nav-hie" onclick="switchNav(\'hie\')" class="unselected">'.$T["hierarchy"].'</li></ul>';
	echo '</div>';
	draw_geo_navigation();
	draw_hie_navigation();
	echo '</div>';
	echo '<a id="nav-toggle" class="visible" onclick="toggleNav();" >&nbsp;</a>';
	echo '</div>';
}

// draw name of current object
function draw_obj_name()
{
	global $main_object;
	
	echo '<h1>';
	echo get_obj_name($main_object);		
	echo '</h1>';
}

// function for drawing values from table "data"
// for comments, see function draw_ratings(...)
function draw_data($data_specs, $data_existence, $data, $data_disclaimers)
{
	global $PAGE, $obj_count, $GS, $T, $objects_string, $years, $names_string;
	
	$chart_names_string = str_replace('<span>', ' ', str_replace("</span>", '', $names_string));
	$rows = count($data_specs);

	echo '<div id="data">';
	if ($PAGE == 'profile') $limit = 1; else $limit = 0;
	$c = 0;
	
	for ($i = 0; $i < $rows; $i++)
	{
		$ID = $data_specs[$i]["ID"];
		$level = $data_specs[$i]["level"];
		$display_level = $data_specs[$i]["level"];
		$name = $data_specs[$i]["short_name"];
		$has_data = $data_specs[$i]["has_data"];
		$datatype = $data_specs[$i]["datatype"];
		if ($datatype) $short_datatype = substr($datatype, 0, 1); else $short_datatype = NULL;
		$explanation = $data_specs[$i]["explanation"];
		$disclaimer = $data_specs[$i]["disclaimer"];
		$formatter_string = get_formatter_string($datatype);

		if ($has_data) $c++; else $c = 0;
		
		if ($level <= $GS["max_data_level_allowed"])
		{
			echo '<div class="level'.min(4, $display_level).(($has_data && $display_level > 1)?($c%2==0?' even':' odd'):'').'" id="d-'.$ID.'">';
			
			if ($PAGE == 'profile')
				if ($has_data) $class = "p-name"; else $class = "p-w-name";
			if ($PAGE == 'comparison')
				if ($has_data) $class = "c-name"; else $class = "c-w-name";
			
			if ($PAGE == 'profile')
				echo '<div class="p-icons">';
			if ($PAGE == 'comparison')
				echo '<div class="c-icons">';
				
			echo (($short_datatype=='n' || $explanation)?'<a id="i-d-'.$ID.'" class="i-plus" onclick="toggleMoreInfo(\'d-'.$ID.'\', \''.$objects_string.'\', \''.$formatter_string.'\', \''.$chart_names_string.'\', \''.$limit.'\', \''.$short_datatype.'\', \''.$T["please_wait"].'\')">&nbsp;</a>':'');
			echo ($disclaimer?'<a class="i-disclaimer" title="'.$disclaimer.'">&nbsp;</a>':'');
			echo '&nbsp;';
			echo '</div>';
			
			echo '<div class="'.$class.'" id="n-d-'.$ID.'">'.$name.'</div>';
			
			if ($has_data)
			{
				for ($o=0; $o<$obj_count; $o++)
				{
					if ($PAGE == 'profile') $class = "p-dw-value"; 
					if ($PAGE == 'comparison') $class = "c-dw-value col-".($o+1);
					if ($short_datatype == 't') $class .= ' left'; else $class .= ' right';
					if ($o == 0 || $PAGE == 'comparison') $class .= ' main'; else $class .= ' another';
	
					if ($data_existence[$o][$i])
					{
						if (array_key_exists($ID, $data[$o]) && $data[$o][$ID] !== NULL)
						{
							if ($data_disclaimers[$o][$ID] !== NULL) $disc_string = '<a class="i-disclaimer" title="'.$data_disclaimers[$o][$ID].'">&nbsp;</a>'; else $disc_string = '';
							echo '<div class="'.$class.'">'.$disc_string.format($data[$o][$ID], $datatype).'</div>';
						}
						else
							echo '<div class="'.$class.'">'.$GS["missing_sign"].'</div>';
					}
					else
						echo '<div class="'.$class.'">'.$GS["absence_sign"].'</div>';
				}
			}
			
			if ($PAGE == 'profile') $class = 'p-more-info-wrapper';
			if ($PAGE == 'comparison') $class = 'c-more-info-wrapper';
			echo '<div class="'.$class.'" id="div-d-'.$ID.'">';
			echo '<div class="explanation-wrapper" id="exp-d-'.$ID.'"></div>';
			echo '<div class="graph-wrapper" id="graph-d-'.$ID.'"></div>';
			echo '</div>';
			echo '</div>';
		}
	}
	
	echo '</div>';
}

// function for drawing values from table "indicators"
// for comments, see function draw_ratings(...)
function draw_indicators($indicators_specs, $indicators_existence, $indicators, $indicator_disclaimers)
{
	global $PAGE, $obj_count, $GS, $T, $objects_string, $years, $names_string;
	
	$chart_names_string = str_replace('<span>', ' ', str_replace("</span>", '', $names_string));
	$rows = count($indicators_specs);

	echo '<div id="indicators">';
	if ($PAGE == 'profile') $limit = 1; else $limit = 0;
	$c = 0;
	
	for ($i = 0; $i < $rows; $i++)
	{
		$ID = $indicators_specs[$i]["ID"];
		$level = $indicators_specs[$i]["level"];
		$display_level = $indicators_specs[$i]["display_level"];
		$name = $indicators_specs[$i]["short_name"];
		$has_data = $indicators_specs[$i]["has_data"];
		$datatype = $indicators_specs[$i]["datatype"];
		if ($datatype) $short_datatype = substr($datatype, 0, 1); else $short_datatype = NULL;
		$legend = $indicators_specs[$i]["legend"];
		$significance = $indicators_specs[$i]["significance"];
		$rating_datatype = $indicators_specs[$i]["rating_datatype"];
		$explanation = $indicators_specs[$i]["explanation"];
		$disclaimer = $indicators_specs[$i]["disclaimer"];
		$min_rating = $indicators_specs[$i]["min_rating"];
		$max_rating = $indicators_specs[$i]["max_rating"];
		$formatter_string = get_formatter_string($datatype);
		
		if ($has_data) $c++; else $c = 0;

		if ($level <= $GS["max_indicator_level_allowed"])
		{
			echo '<div class="level'.min(4, $display_level).(($has_data && $display_level > 1)?($c%2==0?' even':' odd'):'').'" id="i-'.$ID.'">';
			
			if ($PAGE == 'profile')
				echo '<div class="p-icons">';
			if ($PAGE == 'comparison')
				echo '<div class="c-icons">';
			echo (($short_datatype=='n' || $explanation)?'<a id="i-i-'.$ID.'" class="i-plus" onclick="toggleMoreInfo(\'i-'.$ID.'\', \''.$objects_string.'\', \''.$formatter_string.'\', \''.$chart_names_string.'\', \''.$limit.'\', \''.$short_datatype.'\', \''.$T["please_wait"].'\')">&nbsp;</a>':'');
			echo ($disclaimer?'<a class="i-disclaimer" title="'.$disclaimer.'">&nbsp;</a>':'');
			echo '&nbsp;';
			echo '</div>';
			
			if ($PAGE == 'profile')
				if ($has_data) $class = "p-name"; else $class = "p-w-name";			
			if ($PAGE == 'comparison')
				if ($has_data) $class = "c-name"; else $class = "c-w-name";			
			echo '<div class="'.$class.'" id="n-i-'.$ID.'">'.$name.'</div>';
			
			if ($has_data)
			{			
				for ($o=0; $o<$obj_count; $o++)
				{
					if ($PAGE == 'profile')	$class = "p-in-rating"; 
					if ($PAGE == 'comparison') $class = "c-in-rating col-".($o+1);
					if ($short_datatype == 't') $class .= ' left'; else $class .= ' right';
					if ($o == 0 || $PAGE == 'comparison') $class .= ' main'; else $class .= ' another';
					
					if ($PAGE == 'profile') $IR = $GS["profile_indicator_rating"];
					if ($PAGE == 'comparison') $IR = $GS["comparison_indicator_rating"];
					
					if ($IR) // rating of indicator should be displayed
					{
						if ($rating_datatype && $indicators_existence[$o][$i]) // indicator rating
						{
							{
								if (array_key_exists($ID, $indicators[$o]) && $indicators[$o][$ID]["rating"] !== NULL)
								{
									if ($indicators[$o][$ID]["weight"] >= $significance || $indicators[$o][$ID]["weight"] === NULL)
									{
										if ($indicator_disclaimers[$o][$ID] !== NULL) $disc_string = '<a class="i-disclaimer" title="'.$indicator_disclaimers[$o][$ID].'">&nbsp;</a>'; else $disc_string = '';
										$bg_color = get_rating_color($indicators[$o][$ID]["rating"], $min_rating, $max_rating);
										$rating_string = format_rating($indicators[$o][$ID]["rating"], $rating_datatype, $min_rating, $max_rating);										
										if ($legend && $PAGE == 'comparison')
											$legend_string = ' class="rating legend" title="'.format_legend($indicators[$o][$ID]["weight"], $legend).'"';
										else
											$legend_string = ' class="rating"';
										echo '<div class="'.$class.'">'.$disc_string.'<span style="color:'.$GS["rating_text_color"].'; background-color:'.$bg_color.'"'.$legend_string.'>'.$rating_string.'</span></div>';
									}
									else
										echo '<div class="'.$class.'">'.$GS["insignificance_sign"].'</div>';							
								}
								else
									echo '<div class="'.$class.'">'.$GS["missing_sign"].'</div>';
							}
						}
						else
							echo '<div class="'.$class.'">'.$GS["absence_sign"].'</div>';
					}

					if ($PAGE == 'profile')
						if ($IR) $class = "p-in-value"; else $class = "p-iw-value";
					if ($PAGE == 'comparison')
						if ($IR) $class = "c-in-value col-".($o+1); else $class = "c-iw-value col-".($o+1);
					if ($short_datatype == 't') $class .= ' left'; else $class .= ' right';
					if ($o == 0 || $PAGE == 'comparison') $class .= ' main'; else $class .= ' another';

					if ($indicators_existence[$o][$i]) // indicator value
					{
						if (array_key_exists($ID, $indicators[$o]) && $indicators[$o][$ID]["value"] !== NULL)
						{
							if ($indicators[$o][$ID]["weight"] >= $significance || $indicators[$o][$ID]["weight"] === NULL)
							{
								if ($indicator_disclaimers[$o][$ID] !== NULL) $disc_string = '<a class="i-disclaimer" title="'.$indicator_disclaimers[$o][$ID].'">&nbsp;</a>'; else $disc_string = '';
								if ($legend && $PAGE == 'comparison')
									$legend_string = ' class="legend" title="'.format_legend($indicators[$o][$ID]["weight"], $legend).'"';
								else
									$legend_string = '';
								echo '<div class="'.$class.'">'.$disc_string.'<span'.$legend_string.'>'.format($indicators[$o][$ID]["value"], $datatype).'</span></div>';
							}
							else
								echo '<div class="'.$class.'">'.$GS["insignificance_sign"].'</div>';
						}
						else
							echo '<div class="'.$class.'">'.$GS["missing_sign"].'</div>';
					}
					else
						echo '<div class="'.$class.'">'.$GS["absence_sign"].'</div>';						
				}
				
				if ($PAGE == 'profile')
				{
					echo '<div class="p-legend">'.($legend?format_legend($indicators[0][$ID]["weight"], $legend):'').'</div>';
				}

			}	

			if ($PAGE == 'profile') $class = 'p-more-info-wrapper';
			if ($PAGE == 'comparison') $class = 'c-more-info-wrapper';
			echo '<div class="'.$class.'" id="div-d-'.$ID.'">';
			echo '<div class="explanation-wrapper" id="exp-i-'.$ID.'"></div>';
			echo '<div class="graph-wrapper" id="graph-i-'.$ID.'"></div>';
			echo '</div>';
			echo '</div>';
		}
	}
	
	echo '</div>';
}

// function for drawing values from table "ratings"
function draw_ratings($ratings_specs, $ratings_existence, $ratings, $rating_disclaimers)
{
	global $PAGE, $obj_count, $GS, $T, $objects_string, $years, $names_string;
	
	// 
	$chart_names_string = str_replace('<span>', ' ', str_replace("</span>", '', $names_string)); // remove <span> tag from names drawn in google chart
	$rows = count($ratings_specs); // number of rating rows drawn in profile
	
	echo '<div id="ratings"><div id="ratings-helper">';
	if ($PAGE == 'profile') $limit = 1; else $limit = 0; // if chart is drawn in "profile" page, limit nuber of lines drawn in chart to 1 (color is therefore specified), else do not specify colors
	$c = 0;
	
	for ($i = 0; $i < $rows; $i++)
	{
		// specification for each row
		$ID = $ratings_specs[$i]["ID"];
		$level = $ratings_specs[$i]["level"];
		$display_level = $ratings_specs[$i]["display_level"];
		$name = $ratings_specs[$i]["short_name"];
		$has_data = $ratings_specs[$i]["has_data"];
		$datatype = $ratings_specs[$i]["datatype"];
		if ($datatype) $short_datatype = substr($datatype, 0, 1); else $short_datatype = NULL;
		$legend = $ratings_specs[$i]["legend"];
		$significance = $ratings_specs[$i]["significance"];
		$explanation = $ratings_specs[$i]["explanation"];
		$disclaimer = $ratings_specs[$i]["disclaimer"];
		$min_rating = $ratings_specs[$i]["minimum"];
		$max_rating = $ratings_specs[$i]["maximum"];
		$formatter_string = get_formatter_string($datatype);
		
		if ($has_data && $display_level >= 2) $c++; else $c = 0; // reset background coloring if display level is smaller than 2

		if ($level <= $GS["max_rating_level_allowed"])
		{
			echo '<div class="level'.min(4, $display_level).(($has_data && $display_level > 1)?($c%2==0?' even':' odd'):'').'" id="r-'.$ID.'">'; // style for whole row

			if ($PAGE == 'profile') echo '<div class="p-icons">';
			if ($PAGE == 'comparison') echo '<div class="c-icons">';
			
			echo (($short_datatype=='n' || $explanation)?'<a id="i-r-'.$ID.'" class="i-plus" onclick="toggleMoreInfo(\'r-'.$ID.'\', \''.$objects_string.'\', \''.$formatter_string.'\', \''.$chart_names_string.'\', \''.$limit.'\', \''.$short_datatype.'\', \''.$T["please_wait"].'\')">&nbsp;</a>':''); // button for displaying google chart and explanation
			echo ($disclaimer?'<a class="i-disclaimer" title="'.$disclaimer.'">&nbsp;</a>':''); // disclaimer tooltip
			echo '&nbsp;';
			echo '</div>';
			
			if ($PAGE == 'profile')
				if ($has_data) $class = "p-name"; else $class = "p-w-name"; // if current row does not have data, div wrapping its name will be wider
			if ($PAGE == 'comparison')
				if ($has_data) $class = "c-name"; else $class = "c-w-name"; // if current row does not have data, div wrapping its name will be wider
			echo '<div class="'.$class.'" id="n-r-'.$ID.'">'.$name.'</div>'; // row name itself
			
			if ($has_data)
			{
				for ($o=0; $o<$obj_count; $o++) // displays value for all objects selected (if $PAGE == 'profile', $obj_count = 1)
				{
					// styling current column				
					if ($PAGE == 'profile') $class = "p-rw-rating";
					if ($PAGE == 'comparison') $class = "c-rw-rating col-".($o+1);
					$class .= ' center';
					
					if ($ratings_existence[$o][$i]) // rating 'should' exist
					{
						if (array_key_exists($ID, $ratings[$o]) && $ratings[$o][$ID]["rating"] !== NULL) // rating 'does' exist
						{
							if ($ratings[$o][$ID]["weight"] >= $significance || $ratings[$o][$ID]["weight"] === NULL) // rating is relevant (its weight is greater than or equal to significance)
							{
								if ($rating_disclaimers[$o][$ID] !== NULL) $disc_string = '<a class="i-disclaimer" title="'.$rating_disclaimers[$o][$ID].'">&nbsp;</a>'; else $disc_string = ''; // disclaimer
								$bg_color = get_rating_color($ratings[$o][$ID]["rating"], $min_rating, $max_rating); // color of rating background
								$rating_string = format_rating($ratings[$o][$ID]["rating"], $datatype, $min_rating, $max_rating); // formatting rating value
								if ($legend && $PAGE == 'comparison')
									$legend_string = ' class="rating legend" title="'.format_legend($ratings[$o][$ID]["weight"], $legend).'"'; // if $PAGE == comparison, display legend as tooltip; if $PAGE == profile, display legend in new column
								else
									$legend_string = ' class="rating"';
								echo '<div class="'.$class.'">'.$disc_string.'<span style="color:'.$GS["rating_text_color"].'; background-color:'.$bg_color.'"'.$legend_string.'>'.$rating_string.'</span></div>'; // column with current value (styled and formatted)
							}
							else // rating is not relevant
								echo '<div class="'.$class.'">'.$GS["insignificance_sign"].'</div>';						
						}
						else // rating 'does not' exist
							echo '<div class="'.$class.'">'.$GS["missing_sign"].'</div>';
					}
					else // rating 'should' not exist
						echo '<div class="'.$class.'">'.$GS["absence_sign"].'</div>';
	
					// display legend in new column (if no legend is specified, column will be empty)
					if ($PAGE == 'profile')
					{
						echo '<div class="p-legend">'.($legend?format_legend($ratings[0][$ID]["weight"], $legend):'').'</div>';
					}
				}
			}
			
			// div for google chart and explanation - visible (but empty) from onload
			if ($PAGE == 'profile') $class = 'p-more-info-wrapper';
			if ($PAGE == 'comparison') $class = 'c-more-info-wrapper';
			echo '<div class="'.$class.'" id="div-d-'.$ID.'">';
			echo '<div class="explanation-wrapper" id="exp-r-'.$ID.'"></div>';
			echo '<div class="graph-wrapper" id="graph-r-'.$ID.'"></div>';
			echo '</div>';
			echo '</div>';
		}
	}
	
	echo '</div></div>';
}

// get pagination real string in format [order of first row]-[order of last row] 
function gprs($page, $page_size)
{
	return (($page - 1) * $page_size + 1) . '-' . $page * $page_size;
}

// draw pagination below ranking
function draw_rankings_pagination($values_string, $criteria_string, $display_string, $years_string, $found_rows)
{
	global $GS, $T;
	
	$display_parts = explode(",", $display_string);
	$range = explode("-", $display_parts[2]);
	$order_by = $display_parts[0].','.$display_parts[1].','; // column and direction for sorting
	$start = $range[0]; // first result to show
	$page_size = $GS["default_ranking_rows"];
	$pages = ceil($found_rows / $page_size); // total number of pages
	$page = ceil($start / $page_size); // current page based on $range of $displasy_string
	$page = min($pages, $page);
	
	// all pages will share
	$common_string = "/rankings/".$values_string."/".$criteria_string."/".$years_string."/".$order_by;
	
	// pagination
	echo '
	<div id="pagination">
		<ul>';
		if ($page > 1) 
		{
			echo('<li id="page1" class="first"><a href="'.$common_string.gprs(1, $page_size).'">'.$T["first_page"].'</a></li>');
			echo('<li id="showprev"><a href="'.$common_string.gprs($page - 1, $page_size).'">&lt;</a></li>');
		}
			
		if ($page <= 3)
		{
			if ($page == 1 && $pages > 1) 
			{
				for ($i = 1; $i <= min(3, $pages); $i++)
				{
					if ($page == $i) $selectedclass = 'class="selected'.($i == 1?' first" ':'" '); else $selectedclass = '';
					echo '<li id="page'.$i.'" '.$selectedclass.'><a href="'.$common_string.gprs($i, $page_size).'">'.$i.'</a></li>';
				}
				if ($pages > 4)
					echo '<li class="page-none">...</li>';
			}
			else
			{
				for ($i = 1; $i <= min($page + 2, $pages); $i++)
				{
					if ($page == $i) $selectedclass = 'class="selected" '; else $selectedclass = '';
					echo '<li id="page'.$i.'" '.$selectedclass.'><a href="'.$common_string.gprs($i, $page_size).'">'.$i.'</a></li>';
				}
					if ($pages > $page + 3)
						echo '<li class="page-none">...</li>';
			}
		}
		else
		{
			echo '<li class="page-none">...</li>';
			for ($i = $page - 2; $i <= $page; $i++)
			{
				if ($page == $i) $selectedclass = 'class="selected" '; else $selectedclass = '';
				echo '<li id="page'.$i.'" '.$selectedclass.'><a href="'.$common_string.gprs($i, $page_size).'">'.$i.'</a></li>';
			}
			if ($page >= $pages - 2)
			{
				for ($i = $page + 1; $i <= $pages; $i++)
					echo '<li id="page'.$i.'"><a href="'.$common_string.gprs($i, $page_size).'">'.$i.'</a></li>';
			}
			else
			{
				for ($i = $page + 1; $i <= $page + 2; $i++)
				{
					echo '<li id="page'.$i.'"><a href="'.$common_string.gprs($i, $page_size).'">'.$i.'</a></li>';
				}
				echo '<li class="page-none">...</li>';
			}
		}
		if ($page < $pages) 
		{
			echo '<li id="shownext"><a href="'.$common_string.gprs($page + 1, $page_size).'">&gt;</a></li>';
			echo '<li id="page'.$pages.'"><a href="'.$common_string.gprs($pages, $page_size).'">'.$T["last_page"].'</a></li>';
		}
	echo '
		</ul>
	</div>';
}

// draw ranking table
function draw_rankings($data, $values_string, $criteria_string, $years_string, $display_string, $disclaimers, $draw_tooltips = TRUE, $draw_header = TRUE, $sortable = TRUE, $highlight_sortcol = TRUE, $pagination = TRUE, $show_firt_col = TRUE)
{
	// $draw_tooltips - if set to 1, disclaimers (if exist) and legends (explaining significance of value) for each value are displayed as tooltip; if set to 0, no tooltips will be displayed
	// $draw_header - if set to 1, header (column names) will be drawh; if set to 0, header will not be drawn
	// $sortable - if set to 1 and $draw_header = 1, table can be sorted by each column; if set to 0, table cannot be sorted
	// $highlight_sortcol - if set to 1, background color of sort column will be darker; if set to 0, all columns will have the same background color
	// $pagination - if set to 1, navigation between pages will be displayed; if set to 0, navigation will not be displayed
	// $show_first_col - if set to 1, first column with number of current row will be displayed; if set to 0, first column will not be displayed
	
	global $views, $GS, $T;
	
	$IDs = $data[0]; // twodimensional array - first dimension is entity ID, second is ID of individual value displayed for selected entity
	$values = $data[1]; // twodimensional array - first dimension is entity ID, second is individual value displayed for selected entity
	$weights = $data[2]; // twodimensional array - first dimension is entity ID, second is weight of individual value displayed for selected entity
	$entities = $data[3]; // array of entity IDs
	$columns = $data[4]; // twodimensional array - first is column ID (includint first letter of type (rating, indicator, data) - for example, 'r00'), second is row from database with specification of current column
	$found_rows = $data[5]; // number of found rows

	// parsing display string for pagination and sorting
	$display_parts = explode(",",$display_string);
	$display_col = $display_parts[0];
	$display_order = $display_parts[1];
	$display_new_order = $display_order == 'asc'?'desc':'asc';
	$display_range = $display_parts[2];	
	$display_range = explode("-", $display_range);
	$display_start = intval($display_range[0]);
	$display_end = intval($display_range[1]);
	
	$legend = array();
	
	echo '<table class="rankings-table">';
	
	// header will be drawn
	if ($draw_header)
	{
		echo '<tr class="rt-header-row">';
		if ($show_firt_col)
			echo '<td>&nbsp;</td>'; // first column
		
		// default class for header columns
		if ($sortable)
		{
			// class for "name" column
			if ($display_col == 'name')
			{
				if ($display_order == 'desc') $sort_class = ' rt-sorted-down';
				if ($display_order == 'asc') $sort_class = ' rt-sorted-up';
			}
			else
				$sort_class = ' rt-sortable';
		}
		else
			$sort_class = '';
		
		// header of "name" column	
		echo '<td class="left'.$sort_class.'">';
		if ($display_col == 'name') $order = $display_new_order; else $order = 'asc'; // if sort column is 'name', sort by defined order, else default order is ascending (from A to Z)
		if ($sortable) // wrap column name in <a> that will sort table by current column
			echo '<a href="/rankings/'.$values_string.'/'.$criteria_string.'/'.$years_string.'/name,'.$order.',1-'.$GS["default_ranking_rows"].'">';
		echo '<div>'.ucfirst($T["name"]).'</div>';
		if ($sortable) // end of wrap
			echo '</a>';
		echo '</td>';
		
		// do the same as above but for actual selected "data" columns, not for "name" column
		foreach ($columns as $column_type => $column_data)
		{
			$legend[$column_type] = $column_data["legend"];
			
			$td_align = substr($column_data["datatype"], 0, 1) == 't'?'left':'right';
			if ($sortable)
			{
				if ($column_type == $display_col)
				{
					if ($display_order == 'desc') $sort_class = ' rt-sorted-down';
					if ($display_order == 'asc') $sort_class = ' rt-sorted-up';
				}
				else
					$sort_class = ' rt-sortable';
			}
			else
				$sort_class = '';
			echo '<td class="'.$td_align.$sort_class.'">';
			if ($column_data["disclaimer"] && $draw_tooltips) echo '<a class="i-disclaimer" title="'.$column_data["disclaimer"].'">&nbsp;</a>';
			if ($display_col == $column_type) $order = $display_new_order; else $order = 'desc';
			if ($sortable)
				echo '<a href="/rankings/'.$values_string.'/'.$criteria_string.'/'.$years_string.'/'.$column_type.','.$order.',1-'.$GS["default_ranking_rows"].'">';
			echo '<div>';
			echo ucfirst($column_data["short_name"]);
			echo '</div>';
			if ($sortable)
				echo '</a>';
			echo '</td>';
		}
		echo '</tr>';
	}
	
	$row_number = $display_start;
	
	$c = 0;
	foreach ($entities as $entity_id => $entity_data) // draw ranking line by line, not column by column
	{
		$c++;
		$color_class = ($c % 2 == 0)?'even':'odd';
		echo '<tr class="rt-data-row '.$color_class.'">';
		
		if ($show_firt_col)
			echo '<td class="rt-number">'.number_format($row_number, 0, $GS["decimal_separator"], $GS["thousand_separator"]).'</td>'; // row number
			
		// column with entity name
		if ($highlight_sortcol && $display_col == 'name') $highlight_class = ' rt-sortcol'; else $highlight_class = ''; // styling column background
		echo '<td class="rt-name'.$highlight_class.'">';
		echo '<a class="entity" href="/profile/'.$entity_data["ID"].'/'.$years_string.'">'.$entity_data["name"].($entity_data["sub_name"]?'<span>'.$entity_data["sub_name"].'</span>':'').'</a>'; // entity name
		if ($entity_data["disclaimer"] && $draw_tooltips) echo '<a class="i-disclaimer" title="'.$entity_data["disclaimer"].'">&nbsp;</a>'; // display optional entity disclaimer
		echo '</td>';
		
		$row_values = $values[$entity_id]; // fetch values for actual entity
		$row_weights = $weights[$entity_id]; // fetch weights of values for actual entity (if available)
		$row_IDs = $IDs[$entity_id]; // fetch IDs of values for actial entity
		
		foreach ($columns as $column_type => $column_data) // for current entity, draw all columns
		{
			// support varibles for formatting values
			$significance = $column_data["significance"];
			$character = substr($column_type, 0, 1);
			
			// even each value can have its disclaimer
			if (isset($disclaimers[$character][$row_IDs[$column_type]]) && $draw_tooltips)
				$disclaimer = '<a class="i-disclaimer" title="'.$disclaimers[$character][$row_IDs[$column_type]].'">&nbsp;</a>';
			else
				$disclaimer = '';

			if ($legend[$column_type] && $draw_tooltips) $legend_string = 'legend value" title="'.format_legend($row_weights[$column_type], $legend[$column_type]).'"'; else $legend_string = 'value"'; // optional legend for current value (explaining significance of value)
			if (substr($column_data["datatype"], 0, 1) == 't') $value_align = 'left'; else $value_align = 'right'; // numbers align to the right; text aligh to the left
			if ($highlight_sortcol && $column_type == $display_col) $highlight_class = 'rt-sortcol '; else $highlight_class = ''; // styling column background
			$rating_string = ' class="';
			
			// formatting each value -->
			
			if ($character == 'd') // "data" will be drawn
			{
				if (in_array($entity_data["hierarchy"], $views[$column_type])) // there 'should' be a value
				{
					if (is_array($row_values)) // technical, current entity might not have value in any of selected columns
					{
						if (array_key_exists($column_type, $row_values) && $row_values !== NULL && $row_values[$column_type] !== NULL) // there actually is a value
							$formatted_value = format($row_values[$column_type], $column_data["datatype"]);
						else // there actually is not a value
							$formatted_value = $GS["missing_sign"];
					}
					else // none of selected columns has value for current entity
						$formatted_value = $GS["missing_sign"];
				}
				else // there 'should' not be a value
					$formatted_value = $GS["absence_sign"];
			}
			
			if ($character == 'i') // "indicator" will be drawn
			{
				if (in_array($entity_data["hierarchy"], $views[$column_type])) // there 'should' be a value
				{
					if (is_array($row_values)) // technical, current entity might not have value in any of selected columns
					{
						if (array_key_exists($column_type, $row_values) && $row_values !== NULL && $row_values[$column_type] !== NULL) // there actually is a value
						{
							if ($row_weights[$column_type] >= $significance || $row_weights[$column_type] === NULL) // value is relevant (its weight is greater than or equal to significance)
								$formatted_value = format($row_values[$column_type], $column_data["datatype"]);
							else // value is not relevant
								$formatted_value = $GS["insignificance_sign"];
						}
						else // there actually is not a value
							$formatted_value = $GS["missing_sign"];
					}
					else // none of selected columns has value for current entity
						$formatted_value = $GS["missing_sign"];
				}
				else // there 'should' not be a value
					$formatted_value = $GS["absence_sign"];
			}
			
			if ($character == 'r') // "rating" will be drawn
			{
				if (in_array($entity_data["hierarchy"], $views[$column_type])) // there 'should' be a value
				{
					if (is_array($row_values)) // technical, current entity might not have value in any of selected columns
					{
						if (array_key_exists($column_type, $row_values) && $row_values !== NULL && $row_values[$column_type] !== NULL) // there actually is a value
						{
							if ($row_weights[$column_type] >= $significance || $row_weights[$column_type] === NULL) // value is relevant (its weight is greater than or equal to significance)
							{
								// rating must be specially formated - not only its value, but also style (color and background color)
								$formatted_value = format_rating($row_values[$column_type], $column_data["datatype"], $column_data["minimum"], $column_data["maximum"]);
								$bg_color = get_rating_color($row_values[$column_type], $column_data["minimum"], $column_data["maximum"]);
								$rating_string = ' style="color:'.$GS["rating_text_color"].'; background-color:'.$bg_color.'" class="rating ';
							}
							else // value is not relevant
								$formatted_value = $GS["insignificance_sign"];
						}
						else // there actually is not a value
							$formatted_value = $GS["missing_sign"];
					}
					else // none of selected columns has value for current entity
						$formatted_value = $GS["missing_sign"];
				}
				else
					$formatted_value = $GS["absence_sign"];
			}
			
			// <-- end of formatting each value
			
			// displaying formatted value with its legend, disclaimer and background color
			echo '<td class="rt-data '.$highlight_class.$value_align.'">'.$disclaimer.'<span'.$rating_string.$legend_string.'>'.$formatted_value.'</span></td>';
		}
		
		echo '</tr>';

		$row_number++;
	}
	echo '</table>';
	
	if ($pagination) draw_rankings_pagination($values_string, $criteria_string, $display_string, $years_string, $found_rows);
}

// if entity has disclaimer, draw it
function draw_profile_disclaimer()
{
	global $entity_specification;
	
	if ($entity_specification["disclaimer"])
		echo '<div id="profile-disclaimer">'.$entity_specification["disclaimer"].'</div>';
}

// draw properties of entity from "entity_properties" table
function draw_profile_properties()
{
	global $con, $main_object, $T;
	
	echo '<div id="profile-properties-wrapper">';
	echo '<div id="profile-properties">';
	echo '<h5>'.$T["basic_properties"].'</h5>';
	
	// query for fetching properties of $main_object
	// if $main_object is aggregate, no rows will be found and empty table will be drawn
	$properties_query_string = "
	SELECT 
	`entity_properties_list`.`text` AS `name`,
	`entity_properties_list`.`datatype` AS `datatype`,
	`entity_properties`.`value` AS `value`
	FROM `entity_properties` LEFT JOIN `entity_properties_list` ON `entity_properties`.`property_ID` = `entity_properties_list`.`ID` WHERE `entity_properties`.`entity_ID` = '".$main_object."' ORDER BY `entity_properties_list`.`order` ASC";
	$properties_query = mysqli_query($con, $properties_query_string);

	echo '<table id="basic-properties">';

	// drawing of fetched basic properties	
	while ($row = mysqli_fetch_array($properties_query))
		echo '<tr><td class="bp-name">'.$row["name"].'</td><td class="bp-value">'.format($row["value"], $row["datatype"]).'</td></tr>';
	
	echo '</table>';
	
	echo '</div>';
	echo '</div>';
}

// draw map centered on entity position in entity profile in "profile" page
function draw_profile_map()
{
	global $entity_specification, $GS, $T;
	
	// maps api
	echo '<script type="text/javascript"
    src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAxuAStM5bxqH7tzfGstbgqxIhxfOMdxMU&sensor=false">
  </script>';
   
	// defining current map
	echo '<script type="text/javascript">
	  var map;
    function initialize() 
		{
      var mapOptions = 
			{
        center: new google.maps.LatLng('.$entity_specification["latitude"].', '.$entity_specification["longitude"].'),
        zoom: '.$GS["profile_map_zoom"].',
        minZoom: 0
      };
      map = new google.maps.Map(document.getElementById("map-canvas"),  mapOptions);
			var marker = new google.maps.Marker({position: new google.maps.LatLng('.$entity_specification["latitude"].', '.$entity_specification["longitude"].'),	map: map});
		}
		google.maps.event.addDomListener(window, "load", initialize);	
	</script>';
	
	// wrapper of map and map itself
	echo '<div id="profile-map-wrapper">';
	echo '<div id="profile-map">';
	echo '<div id="map-canvas" style="height:'.$GS["profile_map_height"].'px"></div>';
	echo '</div>';
	echo '</div>';
}

// draw entire header of object (excluding name) in "profile" page - function is called only for entities, not for aggregates
function draw_profile_head()
{
	global $entity_specification, $T;
	
	echo '<div id="profile-head" style="display: none;">';
	draw_profile_disclaimer();
	draw_profile_properties();
	draw_profile_map();
	echo '<div class="clear"></div>';
	echo '</div>';
	echo '<div class="dummy-center">';
	echo '<a id="profile-head-toggle-button" class="button b-normal b-lightgray" onclick="toggleBP(\''.$T["hide"].'\', \''.$T["show_more"].'\');">'.$T["show_more"].'</a>';
	echo '</div>';
}

// draw panel with year selection
function draw_years()
{
	// although years panel will be drawn for profile, comparison and rankings page and their styling is the same, clicking on years in different pages will produce different results; therefore each case must be drawn separately
	global $PAGE, $GS, $T, $C_ENT;
	
	if ($PAGE == 'profile' || $PAGE == 'comparison')
	{
		global $objects_string, $obj_count, $years;
		$years_a = parse_years($years);
	}
			
	if ($PAGE == 'profile')
	{	
		// display list of year buttons
		echo '<div class="year-buttons">';
		for ($year = $GS["oldest_year"]; $year <= $GS["newest_year"]; $year++)
			// if current $year is selected, highlight it
			echo '<a class="button b-normal b-'.(($year >= $years_a[0] && $year <= $years_a[1])?'dark':'').'gray" href="/profile/'.$objects_string.'/'.$year.'">'.$year.'</a>';
		echo '</div>';

		// display button for adding object to or removing object from comparison basket
		echo '<div class="year-add-remove">';
			if (in_list($C_ENT, $objects_string)) // object is already in basket, so it can be removed
				echo '<a class="fright button b-normal b-yellow" onclick="removeFromBasket(\''.$objects_string.'\')">'.$T["object_remove_comparison"].'</a>';
			else // object is not in basket, so it can be added
			{
				if ($obj_count < $GS["max_comparison_objects"])
					echo '<a class="fright button b-normal b-yellow" onclick="addToBasket(\''.$objects_string.'\', \''.get_obj_name($objects_string).'\')">'.$T["add_to_comparison"].'</a>';
			}
		echo '</div>';
		
		echo '<div class="clear"></div>';
	}
	
	if ($PAGE == 'comparison')
	{
		// display list of year buttons
		echo '<div class="year-buttons">';
		for ($year = $GS["oldest_year"]; $year <= $GS["newest_year"]; $year++)
			// if current $year is selected, highlight it
			echo '<a class="button b-normal b-'.(($year >= $years_a[0] && $year <= $years_a[1])?'dark':'').'gray" href="/comparison/'.$objects_string.'/'.$year.'">'.$year.'</a>';
		echo '</div>';

		// display button for adding new object to comparison - clickng the button will display dialog for selecting entity or aggregate
		echo '<div class="year-add-remove">';
		if ($obj_count < $GS["max_comparison_objects"])
			echo '<a id="changeButton-0" class="fright button b-normal b-yellow" onclick="showCNWindow('.($obj_count+1).', \''.$objects_string.'\', \''.$years.'\')">'.$T["add_to_comparison"].'</a>';
		else
			echo '&nbsp;';
		echo '</div>';
		
		echo '<div class="clear"></div>';
	}

	if ($PAGE == 'rankings')
	{
		global $values_string, $criteria_string, $years_string, $display_string;
		$display_parts = explode(",", $display_string);
		$years_a = parse_years($years_string);
		
		for ($year = $GS["oldest_year"]; $year <= $GS["newest_year"]; $year++)
			// if current $year is selected, highlight it
			echo '<a class="button b-normal b-'.(($year >= $years_a[0] && $year <= $years_a[1])?'dark':'').'gray" href="/rankings/'.$values_string.'/'.$criteria_string.'/'.$year.'/'.$display_parts[0].','.$display_parts[1].',1-'.$GS["default_ranking_rows"].'">'.$year.'</a>';
	}
}

// draw 'header' for comparison - list of compared objects including buttons for removing them from comparison or chaning them to another object
function draw_comparison_navigation()
{
	global $objects, $obj_count, $T, $years, $objects_string, $years;
	
	echo '<div class="cn-dummy">&nbsp;</div>'; // dummy, used in javascript for tracking purposes
	$c = 0;
	foreach ($objects as $object)
	{
		echo '<div class="cn-element-wrapper col-'.($c+1).'">';
		echo '<div class="name"><a href="/profile/'.$object.'/'.$years.'">'.str_replace("<span>", "<br /><span>", get_obj_name($object)).'</a></div>'; // name of current compared object
		
		// create string with all objects excluding the current, objects separated by comma
		$temp_objects = $objects;
		unset($temp_objects[$c]);
		$remaining_objects_string = implode(",", $temp_objects);
		
		// button for removing current object from comparison
		if (count($temp_objects) > 0)
			echo '<a class="button b-normal b-gray" onclick="removeFromBasket(\''.$object.'\'); window.location.href=\'/comparison/'.$remaining_objects_string.'/'.$years.'\'">'.$T["object_remove"].'</a>';
		else
			echo '<a class="button b-normal b-gray" onclick="removeFromBasket(\''.$object.'\'); window.location.href=\'/comparison\'">'.$T["object_remove"].'</a>';
		
		// button for chaning current comparet object to antoher object
		echo '<a id="changeButton-'.($c+1).'" class="button b-normal b-yellow" onclick="showCNWindow('.($c+1).', \''.$objects_string.'\', \''.$years.'\')">'.$T["object_change"].'</a>';
		echo '</div>';
		$c++;
	}
}

?>