<?php

// get values from table "data"
// for comments, see function get_ratings(...)
function get_data($object, $is_entity, $geo, $hie, $geo_level, $hie_level, $years)
{
	global $con, $max_geo_level, $max_hie_level, $GS;
	
	$oldest_year = $years[0];
	$newest_year = $years[1];
	
	$geo_from_bottom = $max_geo_level - $geo_level;
	$hie_from_bottom = $max_hie_level - $hie_level;
	
	if ($max_hie_level >= $GS["max_hierarchy_level_allowed"] || $max_geo_level >= $GS["max_geography_level_allowed"])
		$object = $geo.'-'.$hie;
	
	$query_string = 
	"SELECT
	`data`.`ID` AS `ID`,
	`data`.`type` AS `type`,
	SUM(`data`.`value`) AS `value`
	FROM `data` 
	LEFT JOIN `entities` ON `data`.`entity` = `entities`.`ID`
	LEFT JOIN `data_structure` ON `data`.`type` = `data_structure`.`ID`
	LEFT JOIN `geographical_structure` AS `g0` ON `entities`.`geography` = `g0`.`ID`";
	
	for ($i = 1; $i <= $geo_from_bottom; $i++)
		$query_string .= " LEFT JOIN `geographical_structure` AS `g".$i."` ON `g".($i-1)."`.`parent_ID` = `g".$i."`.`ID`";
	
	$query_string .= " LEFT JOIN `hierarchical_structure` AS `h0` ON `entities`.`hierarchy` = `h0`.`ID`";
	
	for ($i = 1; $i <= $hie_from_bottom; $i++)
		$query_string .= " LEFT JOIN `hierarchical_structure` AS `h".$i."` ON `h".($i-1)."`.`parent_ID` = `h".$i."`.`ID`";
	
	$query_string .= " WHERE 
	`data`.`visibility` = 1
	AND `data`.`value` IS NOT NULL
	AND `data`.`year` >= ".max($oldest_year, $GS["oldest_year"])."
	AND `data`.`year` <= ".min($newest_year, $GS["newest_year"])."
	AND LEFT(`data_structure`.`datatype`, 1) = 'n'";
	
	if ($is_entity)
		$query_string .= " AND `data`.`entity` = '".$object."'";
	else
		$query_string .= "
	AND `g".$geo_from_bottom."`.`ID` = '".$geo."'
	AND `h".$hie_from_bottom."`.`ID` = '".$hie."'";
	
	$query_string .= " GROUP BY `data`.`type`
	ORDER BY `data_structure`.`order` ASC";	

	$query = mysqli_query($con, $query_string);
	
	$output_data = array();
	$output_disclaimers = array();
	
	while ($row = mysqli_fetch_array($query))
	{
		$output_data[$row["type"]] = $row["value"];
		$output_disclaimers[$row["type"]] = $row["ID"];
	}
		
	return array($output_data, $output_disclaimers);
}

function get_text_data($object, $is_entity, $geo, $hie, $geo_level, $hie_level, $years)
{
	global $con, $max_geo_level, $max_hie_level, $GS;
	
	$oldest_year = $years[0];
	$newest_year = $years[1];
	
	$geo_from_bottom = $max_geo_level - $geo_level;
	$hie_from_bottom = $max_hie_level - $hie_level;
	
	if ($max_hie_level >= $GS["max_hierarchy_level_allowed"] || $max_geo_level >= $GS["max_geography_level_allowed"])
		$object = $geo.'-'.$hie;
	
	$query_string = 
	"SELECT
	`data`.`ID` AS `ID`,
	`data`.`type` AS `type`,
	GROUP_CONCAT(`data`.`value` SEPARATOR '#~') AS `value`
	FROM `data` 
	LEFT JOIN `entities` ON `data`.`entity` = `entities`.`ID`
	LEFT JOIN `data_structure` ON `data`.`type` = `data_structure`.`ID`
	LEFT JOIN `geographical_structure` AS `g0` ON `entities`.`geography` = `g0`.`ID`";
	
	for ($i = 1; $i <= $geo_from_bottom; $i++)
		$query_string .= " LEFT JOIN `geographical_structure` AS `g".$i."` ON `g".($i-1)."`.`parent_ID` = `g".$i."`.`ID`";
	
	$query_string .= " LEFT JOIN `hierarchical_structure` AS `h0` ON `entities`.`hierarchy` = `h0`.`ID`";
	
	for ($i = 1; $i <= $hie_from_bottom; $i++)
		$query_string .= " LEFT JOIN `hierarchical_structure` AS `h".$i."` ON `h".($i-1)."`.`parent_ID` = `h".$i."`.`ID`";
	
	$query_string .= " WHERE 
	`data`.`visibility` = 1
	AND `data`.`value` IS NOT NULL
	AND `data`.`year` >= ".max($oldest_year, $GS["oldest_year"])."
	AND `data`.`year` <= ".min($newest_year, $GS["newest_year"])."
	AND LEFT(`data_structure`.`datatype`, 1) = 't'";
	
	if ($is_entity)
		$query_string .= " AND `data`.`entity` = '".$object."'";
	else
		$query_string .= "
	AND `g".$geo_from_bottom."`.`ID` = '".$geo."'
	AND `h".$hie_from_bottom."`.`ID` = '".$hie."'";
	
	$query_string .= " GROUP BY `data`.`type`
	ORDER BY `data_structure`.`order` ASC";
	
	$query = mysqli_query($con, $query_string);
	
	$output_data = array();
	$output_disclaimers = array();
	
	while ($row = mysqli_fetch_array($query))
	{
		$output_data[$row["type"]] = $row["value"];
		$output_disclaimers[$row["type"]] = $row["ID"];
	}
		
	return array($output_data, $output_disclaimers);
}

function get_indicators($object, $is_entity, $geo, $hie, $geo_level, $hie_level, $get_rating, $years)
{
	global $con, $max_geo_level, $max_hie_level, $GS;
	
	$oldest_year = $years[0];
	$newest_year = $years[1];

	$geo_from_bottom = $max_geo_level - $geo_level;
	$hie_from_bottom = $max_hie_level - $hie_level;
	
	if ($max_hie_level >= $GS["max_hierarchy_level_allowed"] || $max_geo_level >= $GS["max_geography_level_allowed"])
		$object = $geo.'-'.$hie;
	
	$query_string = 
	"SELECT
	`indicators`.`ID` AS `ID`,
	`indicators`.`type` AS `type`,
	SUM(`indicators`.`value` * `indicators`.`weight`)/SUM(`indicators`.`weight`) AS `value`, ";
	
	if ($get_rating)
		$query_string .= "SUM(`indicators`.`rating_value` * `indicators`.`weight`)/SUM(`indicators`.`weight`) AS `rating`,";
	
	$query_string .= "
	SUM(`indicators`.`weight`) AS `weight`
	FROM `indicators` 
	LEFT JOIN `entities` ON `indicators`.`entity` = `entities`.`ID`
	LEFT JOIN `indicators_structure` ON `indicators`.`type` = `indicators_structure`.`ID`
	LEFT JOIN `geographical_structure` AS `g0` ON `entities`.`geography` = `g0`.`ID`";
	
	for ($i = 1; $i <= $geo_from_bottom; $i++)
		$query_string .= " LEFT JOIN `geographical_structure` AS `g".$i."` ON `g".($i-1)."`.`parent_ID` = `g".$i."`.`ID`";
	
	$query_string .= " LEFT JOIN `hierarchical_structure` AS `h0` ON `entities`.`hierarchy` = `h0`.`ID`";
	
	for ($i = 1; $i <= $hie_from_bottom; $i++)
		$query_string .= " LEFT JOIN `hierarchical_structure` AS `h".$i."` ON `h".($i-1)."`.`parent_ID` = `h".$i."`.`ID`";
	
	$query_string .= " WHERE 
	`indicators`.`visibility` = 1
	AND `indicators`.`value` IS NOT NULL
	AND `indicators`.`year` >= ".max($oldest_year, $GS["oldest_year"])."
	AND `indicators`.`year` <= ".min($newest_year, $GS["newest_year"])."
	AND LEFT(`indicators_structure`.`datatype`, 1) = 'n'";
	
	if ($is_entity)
		$query_string .= " AND `indicators`.`entity` = '".$object."'";
	else
		$query_string .= "
	AND `g".$geo_from_bottom."`.`ID` = '".$geo."'
	AND `h".$hie_from_bottom."`.`ID` = '".$hie."'";
	
	$query_string .= " GROUP BY `indicators`.`type`
	ORDER BY `indicators_structure`.`order` ASC";
	
	$query = mysqli_query($con, $query_string);
	
	$output_data = array();
	$output_disclaimers = array();
	
	while ($row = mysqli_fetch_array($query))
	{
		$output_data[$row["type"]]["value"] = $row["value"];
		if ($get_rating)
			$output_data[$row["type"]]["rating"] = $row["rating"];
		$output_data[$row["type"]]["weight"] = $row["weight"];
		$output_disclaimers[$row["type"]] = $row["ID"];		
	}
		
	return array($output_data, $output_disclaimers);
}

function get_ratings($object, $is_entity, $geo, $hie, $geo_level, $hie_level, $years)
{
	// $object - entity or aggregate rating are fetched for
	global $con, $max_geo_level, $max_hie_level, $GS;
	
	$oldest_year = $years[0];
	$newest_year = $years[1];

	$geo_from_bottom = $max_geo_level - $geo_level;
	$hie_from_bottom = $max_hie_level - $hie_level;
	
	// cannot fetch ratings for entity or aggregate of higher level than maximum allowed
	if ($max_hie_level >= $GS["max_hierarchy_level_allowed"] || $max_geo_level >= $GS["max_geography_level_allowed"])
		$object = $geo.'-'.$hie;
	
	// query for fetching ratings	
	// what to select
	$query_string = 
	"SELECT
	`ratings`.`ID` AS `ID`,
	`ratings`.`type` AS `type`,
	SUM(`ratings`.`value` * `ratings`.`weight`)/SUM(`ratings`.`weight`) AS `value`,
	SUM(`ratings`.`weight`) AS `weight`
	FROM `ratings` 
	LEFT JOIN `entities` ON `ratings`.`entity` = `entities`.`ID`
	LEFT JOIN `ratings_structure` ON `ratings`.`type` = `ratings_structure`.`ID`
	LEFT JOIN `geographical_structure` AS `g0` ON `entities`.`geography` = `g0`.`ID`";
	
	// geographical and hierarchical criteria might be on any level - to iterate thgough all necessary levels (because table 'entities' stores only information about the lowest level, not about the whole path), table must be joined with itself, maybe even multiple times (based on number of levels)
	for ($i = 1; $i <= $geo_from_bottom; $i++)
		$query_string .= " LEFT JOIN `geographical_structure` AS `g".$i."` ON `g".($i-1)."`.`parent_ID` = `g".$i."`.`ID`";
	
	$query_string .= " LEFT JOIN `hierarchical_structure` AS `h0` ON `entities`.`hierarchy` = `h0`.`ID`";
	
	for ($i = 1; $i <= $hie_from_bottom; $i++)
		$query_string .= " LEFT JOIN `hierarchical_structure` AS `h".$i."` ON `h".($i-1)."`.`parent_ID` = `h".$i."`.`ID`";
	
	// criteria for selection
	$query_string .= " WHERE 
	`ratings`.`visibility` = 1
	AND `ratings`.`value` IS NOT NULL
	AND `ratings`.`year` >= ".max($oldest_year, $GS["oldest_year"])."
	AND `ratings`.`year` <= ".min($newest_year, $GS["newest_year"])."
	AND LEFT(`ratings_structure`.`datatype`, 1) = 'n'";
	
	// object criteria for selection
	if ($is_entity)
		$query_string .= " AND `ratings`.`entity` = '".$object."'";
	else
		$query_string .= "
	AND `g".$geo_from_bottom."`.`ID` = '".$geo."'
	AND `h".$hie_from_bottom."`.`ID` = '".$hie."'";
	
	$query_string .= " GROUP BY `ratings`.`type`
	ORDER BY `ratings_structure`.`order` ASC";
	
	$query = mysqli_query($con, $query_string);
	
	$output_data = array();
	$output_disclaimers = array();
	
	// output ratings, weights and IDs of each rating
	while ($row = mysqli_fetch_array($query))
	{
		$output_data[$row["type"]]["rating"] = $row["value"];
		$output_data[$row["type"]]["weight"] = $row["weight"];
		$output_disclaimers[$row["type"]] = $row["ID"];
	}
		
	return array($output_data, $output_disclaimers);
}

// 'support' function for gettings 'pseudo' column IDs (type of column + ID) with their correct order (from database table)
// used for ranking - to ensure the same order of selected columns regardless of order of their selection
function get_cols($character, $column_IDs)
{
	// result is array of elements, each in format "r[ID]", "i[ID]" or "d[ID]"
	
	global $data_specs, $indicators_specs, $ratings_specs;
	$columns = array();
	$short_character = substr($character, 0, 1);
	
	foreach ($column_IDs as $column_ID)
	{
		$column_ID = str_replace("'", "", $column_ID);
		if ($short_character == 'd') 
		{
			$columns["d".$column_ID] = $data_specs[$column_ID]; 
			$order[] = $data_specs[$column_ID]["order"];
		}
		if ($short_character == 'i') 
		{
			$columns["i".$column_ID] = $indicators_specs[$column_ID]; 
			$order[] = $indicators_specs[$column_ID]["order"];
		}
		if ($short_character == 'r') 
		{
			$columns["r".$column_ID] = $ratings_specs[$column_ID]; 
			$order[] = $ratings_specs[$column_ID]["order"];
		}
	}
	
	array_multisort($order, $columns);
	return $columns;
}

// get all values for ranking based on columns, criteria, years and display
function get_ranking_values($values_string, $criteria_string, $years_string, $display_string, $force_rows = FALSE)
{
	// $values_string - list of columns
	// $criteria_string - string in format [geos]-[hies], where [geos] is list of geographical structure elements and [hies] is list of hierarchica structure elements
	// $years_string - string in format [first_year]-[last_year] or in format [only_year]
	// $display_string - string in format [sorting_column],[sorting_order],[first_row]-[last_row]
	// $force-rows - if set to 1, any number of rows (defined in $display_string) will be displayed; if set to 0, only default_ranking_rows rows will be displayed
	
	global $con, $max_geo_level, $max_hie_level, $geo_table, $hie_table, $GS, $data_specs, $indicators_specs, $ratings_specs;
		
	$good_query = TRUE;

	// ------------------- part 1: store input parameters as strings or arrays usable for query -------------------

	//parsing $values_string, $criteria_string, $years_string and $display_string
	$values_array = explode(",", $values_string);
	$criteria_array = explode("-", $criteria_string);
	if (count($criteria_array) == 2)
	{
		$criteria_type = 'aggregates';
		$criteria_geo = $criteria_array[0];
		$criteria_hie = $criteria_array[1];
		$criteria_geo_array = explode(",", $criteria_geo);
		$criteria_hie_array = explode(",", $criteria_hie);
	}
	else
	{
		$criteria_type = 'entities';
		$criteria_array = explode(",", $criteria_array[0]);
	}
	
	$years_array = parse_years($years_string);
	$oldest_year = $years_array[0];
	$newest_year = $years_array[1];
	if ($display_string != 'order')
	{
		$display_array = explode(",", $display_string);
		$sort_col = $display_array[0];
		$sort_by = $display_array[1];
		$display_limit = $display_array[2];
		$display_limit = explode("-", $display_limit);
		$limit_start = $display_limit[0] - 1;
		$limit_length = $display_limit[1] - $display_limit[0] + 1;
	}
	
	// dividing $columns into data columns, indicator columns and rating columns
	$data_cols = array();
	$indicator_cols = array();
	$rating_cols = array();
	foreach ($values_array as $value)
	{
		if (substr($value, 0, 1) == 'd' && $data_specs[substr($value, 1)]["visibility"] == 1) $data_cols[] = "'".substr($value, 1)."'";
		if (substr($value, 0, 1) == 'i' && $indicators_specs[substr($value, 1)]["visibility"] == 1) $indicator_cols[] = "'".substr($value, 1)."'";
		if (substr($value, 0, 1) == 'r' && $ratings_specs[substr($value, 1)]["visibility"] == 1) $rating_cols[] = "'".substr($value, 1)."'";
	}
	if (count($data_cols) > 0) $data_cols_string = implode(",", $data_cols); else $data_cols_string = FALSE;
	if (count($indicator_cols) > 0) $indicator_cols_string = implode(",", $indicator_cols); else $indicator_cols_string = FALSE;
	if (count($rating_cols) > 0) $rating_cols_string = implode(",", $rating_cols); else $rating_cols_string = FALSE;
	
	// formatting criteria (geographical, hierarchical, entity) into strings usable for query
	if ($criteria_type == 'aggregates')
	{
		$criteria_geo_levels = array();
		$criteria_hie_levels = array();

		foreach ($criteria_geo_array as $cga)
		{
			if ($geo_table[$cga])
			{
				$level = $geo_table[$cga]["level"];
				$criteria_geo_levels[$level][] = "'".$cga."'";
			}
		}

		foreach ($criteria_hie_array as $cha)
		{
			if ($hie_table[$cha])
			{
				$level = $hie_table[$cha]["level"];
				$criteria_hie_levels[$level][] = "'".$cha."'";
			}
		}

		// dividing all stored geographical criteria into arrays, based on geographical level of each criterion - since each 'where' condition in query will contain criteria of only one level;
		for ($i=0; $i<=$max_geo_level; $i++)
			if (isset($criteria_geo_levels[$i])) $criteria_geo_levels_string[$i] = implode(",", $criteria_geo_levels[$i]); else $criteria_geo_levels_string[$i] = FALSE;
		
		// dividing all stored hierarchical criteria into arrays, based on hierarchical level of each criterion - since each 'where' condition in query will contain criteria of only one level;
		for ($i=0; $i<=$max_hie_level; $i++)
			if (isset($criteria_hie_levels[$i])) $criteria_hie_levels_string[$i] = implode(",", $criteria_hie_levels[$i]); else $criteria_hie_levels_string[$i] = FALSE;
	}
	
	if ($criteria_type == 'entities')
	{
		foreach ($criteria_array as &$entity)
			$entity = "'".$entity."'";
		
		$criteria_entities_string = implode(",", $criteria_array);
	}
		
	// ------------------- part 2: find entities satisfying ordering conditions and criteria -------------------
	// order of found entities must be the same as order of rows in final ranking, therefore sort column and order is very important
	
	$sort_character_short = substr($sort_col, 0, 1);
	$sort_type = substr($sort_col, 1);
	if ($sort_character_short == 'd') $character = 'data';
	if ($sort_character_short == 'i') $character = 'indicators';
	if ($sort_character_short == 'r') $character = 'ratings';
	// ordered by name or by the order of criteria (used when criteria consist of list of entities, not list of geographical and hierarchical elements)
	if ($sort_col == 'name' || $display_string == 'order')
	{
		$entities_query_string = 
		"SELECT SQL_CALC_FOUND_ROWS
		`entities`.*
		FROM `entities`";
		
		// criteria are geographical and hierarchical elements
		// geographical and hierarchical criteria might be on any level - to iterate thgough all necessary levels (because table 'entities' stores only information about the lowest level, not about the whole path), table must be joined with itself, maybe even multiple times (based on number of levels)
		if ($criteria_type == 'aggregates')
		{
			$entities_query_string .= " LEFT JOIN `geographical_structure` AS `g0` ON `entities`.`geography` = `g0`.`ID`";
			
			for ($i = 1; $i <= $max_geo_level; $i++)
				$entities_query_string .= " LEFT JOIN `geographical_structure` AS `g".$i."` ON `g".($i-1)."`.`parent_ID` = `g".$i."`.`ID`";
			
			$entities_query_string .= " LEFT JOIN `hierarchical_structure` AS `h0` ON `entities`.`hierarchy` = `h0`.`ID`";
			
			for ($i = 1; $i <= $max_hie_level; $i++)
				$entities_query_string .= " LEFT JOIN `hierarchical_structure` AS `h".$i."` ON `h".($i-1)."`.`parent_ID` = `h".$i."`.`ID`";
		}
		
		$entities_query_string .= " WHERE `entities`.`visibility` = 1";

		// defining criteria itself based on criteria strings created above		
		if ($criteria_type == 'aggregates')
		{
			$geo_criteria = array();
			for ($i=0; $i<=$max_geo_level; $i++)
				if ($criteria_geo_levels_string[$i] !== FALSE)
					$geo_criteria[] = "(`g".($max_geo_level - $i)."`.`ID` IN (".$criteria_geo_levels_string[$i]."))";
			if (count($geo_criteria) > 0) $geo_criteria_string = implode(" OR ", $geo_criteria); else $geo_criteria_string = FALSE;
			if ($geo_criteria_string !== FALSE) $entities_query_string .= " AND (".$geo_criteria_string.")";
					
			$hie_criteria = array();
			for ($i=0; $i<=$max_hie_level; $i++)
				if ($criteria_hie_levels_string[$i] !== FALSE)
					$hie_criteria[] = "(`h".($max_hie_level - $i)."`.`ID` IN (".$criteria_hie_levels_string[$i]."))";
			if (count($hie_criteria) > 0) $hie_criteria_string = implode(" OR ", $hie_criteria); else $hie_criteria_string = FALSE;
			if ($hie_criteria_string !== FALSE) $entities_query_string .= " AND (".$hie_criteria_string.")";
		}
		
		// very simple case - no need of joining geographical and hierarchical structure tables, just select appropriate entities
		if ($criteria_type == 'entities')
			$entities_query_string .= " AND `entities`.`ID` IN(".$criteria_entities_string.")";

		// how many rows to select
		if ($force_rows)
			$ll = $limit_length;
		else
			$ll = min($limit_length, $GS["default_ranking_rows"]);
		
		if ($display_string != 'order')
			$entities_query_string .= " ORDER BY `entities`.`name` ".$sort_by." LIMIT ".$limit_start.", ".$ll.";";
		else
		// as said above, if sort criteria == 'order', order etnties found by their order in criteria string
			$entities_query_string .= " ORDER BY FIELD(`entities`.`ID`, ".$criteria_entities_string.");";
	}
	else
	{
		$entities_query_string = 
		"SELECT SQL_CALC_FOUND_ROWS ";
		
		// defining values for sorting column
		
		// sorting coumn is "data" type
		if ($character == 'data') 
		{
			$datatype = $data_specs[$sort_type]["datatype"];
			if (!$datatype) $good_query = FALSE;
			// sorting data column consits of texts
			if (substr($datatype, 0, 1) == 't')
			{
				$entities_query_string .= " GROUP_CONCAT(`data`.`value` SEPARATOR '#~') AS `final_value`";
				$final_value_string = "GROUP_CONCAT(`data`.`value` SEPARATOR '#~')";
			}
			// sorting data column consits of numbers
			if (substr($datatype, 0, 1) == 'n')
			{
				$entities_query_string .= " SUM(`data`.`value`) AS `final_value`";
				$final_value_string = "SUM(`data`.`value`)";
			}
		}

		// sorting coumn is "indicator" type
		if ($character == 'indicators')
		{
			$entities_query_string .= " SUM(`indicators`.`value`*`indicators`.`weight`)/SUM(`indicators`.`weight`) AS `final_value`";
			$final_value_string = "SUM(`indicators`.`value`*`indicators`.`weight`)/SUM(`indicators`.`weight`)";
		}

		// sorting coumn is "rating" type
		if ($character == 'ratings')
		{
			$entities_query_string .= " SUM(`".$character."`.`value`*`ratings`.`weight`)/SUM(`ratings`.`weight`) AS `final_value`";
			$final_value_string = "SUM(`".$character."`.`value`*`ratings`.`weight`)/SUM(`ratings`.`weight`)";
		}
	
		// entity ID and entity pseudo-ID (including ID of sorting column) used for grouping
		$entities_query_string .= ", CONCAT(`".$character."`.`entity`, '-', `".$character."`.`type`) AS `concat_ID`, 
		`".$character."`.`entity` AS `ID`,
		`entities`.*
		FROM `".$character."` 
		LEFT JOIN `entities` ON `".$character."`.`entity` = `entities`.`ID`";
		
		// geographical and hierarchical criteria might be on any level - to iterate thgough all necessary levels (because table 'entities' stores only information about the lowest level, not about the whole path), table must be joined with itself, maybe even multiple times (based on number of levels)
		if ($criteria_type == 'aggregates')
		{
			$entities_query_string .= "	LEFT JOIN `geographical_structure` AS `g0` ON `entities`.`geography` = `g0`.`ID`";
		
			for ($i = 1; $i <= $max_geo_level; $i++)
				$entities_query_string .= " LEFT JOIN `geographical_structure` AS `g".$i."` ON `g".($i-1)."`.`parent_ID` = `g".$i."`.`ID`";
			
			$entities_query_string .= " LEFT JOIN `hierarchical_structure` AS `h0` ON `entities`.`hierarchy` = `h0`.`ID`";
			
			for ($i = 1; $i <= $max_hie_level; $i++)
				$entities_query_string .= " LEFT JOIN `hierarchical_structure` AS `h".$i."` ON `h".($i-1)."`.`parent_ID` = `h".$i."`.`ID`";
		}

		// criteria
		// basic criteria
				
		$entities_query_string .= " WHERE 
		`".$character."`.`visibility` = 1
		AND `entities`.`visibility` = 1
		AND `".$character."`.`type` = '".$sort_type."'
		AND `".$character."`.`year` >= ".max($oldest_year, $GS["oldest_year"])."
		AND `".$character."`.`year` <= ".min($newest_year, $GS["newest_year"]);
		
		// geographical and heirarchical criteria
		if ($criteria_type == 'aggregates')
		{
			$geo_criteria = array();
			for ($i=0; $i<=$max_geo_level; $i++)
				if ($criteria_geo_levels_string[$i] !== FALSE)
					$geo_criteria[] = "(`g".($max_geo_level - $i)."`.`ID` IN (".$criteria_geo_levels_string[$i]."))";
			if (count($geo_criteria) > 0) $geo_criteria_string = implode(" OR ", $geo_criteria); else $geo_criteria_string = FALSE;
			if ($geo_criteria_string !== FALSE) $entities_query_string .= " AND (".$geo_criteria_string.")";
					
			$hie_criteria = array();
			for ($i=0; $i<=$max_hie_level; $i++)
				if ($criteria_hie_levels_string[$i] !== FALSE)
					$hie_criteria[] = "(`h".($max_hie_level - $i)."`.`ID` IN (".$criteria_hie_levels_string[$i]."))";
			if (count($hie_criteria) > 0) $hie_criteria_string = implode(" OR ", $hie_criteria); else $hie_criteria_string = FALSE;
			if ($hie_criteria_string !== FALSE) $entities_query_string .= " AND (".$hie_criteria_string.")";
		}
		
		// very simple criteria - no need of joining geographical and hierarchical structure tables, just select appropriate entities				
		if ($criteria_type == 'entities')
			$entities_query_string .= " AND `entities`.`ID` IN(".$criteria_entities_string.")";

		// how many rows to select
		if ($force_rows)
			$ll = $limit_length;
		else
			$ll = min($limit_length, $GS["default_ranking_rows"]); 

		// finalizing query string
		$entities_query_string .= " GROUP BY `concat_ID` ORDER BY ".$final_value_string." IS NOT NULL DESC, `final_value` ".$sort_by.", `entities`.`name` ASC LIMIT ".$limit_start.", ".$ll.";";
	}
	
	// query for created string, storing found entities into string used in third part
	$entities = array();
	$selected_entities = array();
	
	$entities_query = mysqli_query($con, $entities_query_string);
	
	if ($good_query && $entities_query)
	{
		// getting number of found rows
		$found_rows_query = mysqli_query($con, "SELECT FOUND_ROWS()");
		$found_rows_row = mysqli_fetch_array($found_rows_query);
		$found_rows = floatval($found_rows_row[0]);
		
		// getting found entities
		while ($row = mysqli_fetch_array($entities_query))
		{
			$selected_entities[] = "'".$row["ID"]."'";
			$entities[$row["ID"]] = $row;
		}
		$selected_entities_string = implode(",", $selected_entities);
	}
	
	if (!$selected_entities_string) $selected_entities_string = "''";
	
	// ------------------- part 3: find all data for found entities -------------------
	// now, when columns and entities displayed in ranking are defined, final query for getting ranking values is simple
	
	// "data" columns based on selected entities and columns
	$data_query_string = 
	"SELECT
	'data' AS `character`,
	`data`.`entity` AS `entity_ID`,
	`data`.`ID` AS `ID`,
	`data`.`type` AS `type`,
	SUM(`data`.`value`) AS `value`,
	NULL AS `weight`,
	CONCAT(`data`.`entity`, '-', `data`.`type`) AS `concat_ID`	FROM `data` 
	LEFT JOIN `entities` ON `data`.`entity` = `entities`.`ID`
	LEFT JOIN `data_structure` ON `data`.`type` = `data_structure`.`ID`
	WHERE `data`.`visibility` = 1
	AND `entities`.`visibility` = 1
	AND `data`.`entity` IN (".$selected_entities_string.")
	AND `data`.`type` IN (".$data_cols_string.")
	AND `data`.`year` >= ".max($oldest_year, $GS["oldest_year"])."
	AND `data`.`year` <= ".min($newest_year, $GS["newest_year"])."
	GROUP BY `concat_ID` ORDER BY `data_structure`.`order` ASC";
	
	// "indicator" columns based on selected entities and columns
	$indicators_query_string = 
	"SELECT
	'indicators' AS `character`,
	`entities`.`ID` AS `entity_ID`,
	`indicators`.`ID` AS `ID`,
	`indicators`.`type` AS `type`,
	SUM(`indicators`.`value`*`indicators`.`weight`)/SUM(`indicators`.`weight`) AS `value`,
	SUM(`indicators`.`weight`) AS `weight`,
	CONCAT(`indicators`.`entity`, '-', `indicators`.`type`) AS `concat_ID`
	FROM `indicators` 
	LEFT JOIN `entities` ON `indicators`.`entity` = `entities`.`ID`
	LEFT JOIN `indicators_structure` ON `indicators`.`type` = `indicators_structure`.`ID`
	WHERE `indicators`.`visibility` = 1
	AND `entities`.`visibility` = 1
	AND `indicators`.`entity` IN (".$selected_entities_string.")
	AND `indicators`.`type` IN (".$indicator_cols_string.")
	AND `indicators`.`year` >= ".max($oldest_year, $GS["oldest_year"])."
	AND `indicators`.`year` <= ".min($newest_year, $GS["newest_year"])."
	GROUP BY `concat_ID` ORDER BY `indicators_structure`.`order` ASC";

	// "rating" columns based on selected entities and columns
	$ratings_query_string = 
	"SELECT
	'ratings' AS `character`,
	`entities`.`ID` AS `entity_ID`,
	`ratings`.`ID` AS `ID`,
	`ratings`.`type` AS `type`,
	SUM(`ratings`.`value`*`ratings`.`weight`)/SUM(`ratings`.`weight`) AS `value`,
	SUM(`ratings`.`weight`) AS `weight`,
	CONCAT(`ratings`.`entity`, '-', `ratings`.`type`) AS `concat_ID`
	FROM `ratings` 
	LEFT JOIN `entities` ON `ratings`.`entity` = `entities`.`ID`
	LEFT JOIN `ratings_structure` ON `ratings`.`type` = `ratings_structure`.`ID`
	WHERE 
	`ratings`.`visibility` = 1
	AND `entities`.`visibility` = 1
	AND `ratings`.`entity` IN (".$selected_entities_string.")
	AND `ratings`.`type` IN (".$rating_cols_string.")
	AND `ratings`.`year` >= ".max($oldest_year, $GS["oldest_year"])."
	AND `ratings`.`year` <= ".min($newest_year, $GS["newest_year"])."
	GROUP BY `concat_ID` ORDER BY `ratings_structure`.`order` ASC";
		
	// finding which of three "queries" above are empty and which are not
	$nonempty_parts = array();
	$columns = array();
	
	if ($rating_cols_string) 
	{
		$nonempty_parts[] = "(".$ratings_query_string.")";
		$columns = array_merge($columns, get_cols("ratings", $rating_cols));
	}
	if ($indicator_cols_string) 
	{
		$nonempty_parts[] = "(".$indicators_query_string.")";
		$columns = array_merge($columns, get_cols("indicators", $indicator_cols));
	}
	if ($data_cols_string) 
	{
		$nonempty_parts[] = "(".$data_query_string.")";
		$columns = array_merge($columns, get_cols("data", $data_cols));
	}

	// merge nonempty "queries" above into one main query (to get all columns "at once"), order found rows by list of entities defined in the second part
	$query_string = "SELECT * FROM (".implode(' UNION ', $nonempty_parts).") AS t ORDER BY FIELD(`character`, 'ratings', 'indicators', 'data'), FIELD(`entity_ID`, ".$selected_entities_string.")";
	
	$IDs = array();
	$values = array();
	$weights = array();
	
	// write query results into final arrays
	$query = mysqli_query($con, $query_string);
	if ($query)
	{
		while ($row = mysqli_fetch_array($query))
		{
			$type = substr($row["character"], 0, 1).$row["type"];
			$IDs[$row["entity_ID"]][$type] = $row["ID"];
			$values[$row["entity_ID"]][$type] = $row["value"];
			$weights[$row["entity_ID"]][$type] = $row["weight"];
		}
	}
	
	return array($IDs, $values, $weights, $entities, $columns, $found_rows);
}

// get disclaimers for given value IDs
function get_ranking_disclaimers($value_IDs, $entities, $columns)
{
	// $value_IDs - twodimensional array, first dimension is ID of entity, second dimension is ID of particular value for selected entity
	// $eentities - twodimensional array, first dimension is ID of entity, second is row with entity specification from database table
	// $columns - twodimensional array, first dimension is ID of column, second is row with column specification from database table
	
	global $con;
	
	$data_IDs = array();
	$indicator_IDs = array();
	$rating_IDs = array();
	
	// divide value_IDs into three simple arrays, each array representing all IDs for each type of value (data, indicators and ratings)
	foreach ($entities as $entity_id => $entity_data)
	{
		foreach ($columns as $column_id => $column_data)
		{
			$character = substr($column_id, 0, 1);
			$value_IDs_row = $value_IDs[$entity_id];
			if ($character == 'd') $data_IDs[] = "'".$value_IDs_row[$column_id]."'";
			if ($character == 'i') $indicator_IDs[] = "'".$value_IDs_row[$column_id]."'";
			if ($character == 'r') $rating_IDs[] = "'".$value_IDs_row[$column_id]."'";
		}
	}
	
	// all elements from array will be imploded into string (for MySQL query)
	if (count($data_IDs) > 0) 
	{
		$data_IDs_string = implode(",", $data_IDs);
		$data_part = "(`value_type` = 'data' AND `value_ID` IN (".$data_IDs_string."))";
	}
	if (count($indicator_IDs) > 0) 
	{
		$indicator_IDs_string = implode(",", $indicator_IDs);
		$indicators_part = "(`value_type` = 'indicators' AND `value_ID` IN (".$indicator_IDs_string."))";
	}
	if (count($rating_IDs) > 0) 
	{
		$rating_IDs_string = implode(",", $rating_IDs);
		$ratings_part = "(`value_type` = 'ratings' AND `value_ID` IN (".$rating_IDs_string."))";
	}
	
	// query itself
	$disclaimer_query_string = "
	SELECT * FROM `disclaimers` WHERE (`visibility` = 1) AND (FALSE OR ";
	
	if ($data_part)	$disclaimer_query_string .= $data_part . ' OR ';
	if ($indicators_part)	$disclaimer_query_string .= $indicators_part . ' OR ';
	if ($ratings_part)	$disclaimer_query_string .= $ratings_part . ' OR ';
	
	$disclaimer_query_string = substr($disclaimer_query_string, 0, -4) . ')';
	$disclaimer_query = mysqli_query($con, $disclaimer_query_string);
	
	$disclaimers = array();
	
	// fetching query result
	while ($row = mysqli_fetch_array($disclaimer_query))
	{
		$character = substr($row["value_type"], 0, 1);
		$disclaimers[$character][$row["value_ID"]] = $row["text"];
	}
	
	return $disclaimers;
	
}

// get list of relevant ratings, indicators and data for selected array of hierarchies (since some entities may have different set of relevant ratings, indicators and values than others)
function get_view($hie_array)
{
	global $con, $hie_tree;
	
	// since array of selected hierarchies may have different hierarchies than are specified in "views" table, we need to "map" selected hierarchies to those present in "views" table
	if (!is_array($hie_array)) $hie_array = array($hie_array);
	
	// at first, select all hierarchies defined in "views" table
	$all_hierarchy_IDs_query = mysqli_query($con, "SELECT DISTINCT `hierarchy_ID` FROM `views`");
	$all_hierarchy_IDs = array();
	while ($row = mysqli_fetch_array($all_hierarchy_IDs_query))
		$all_hierarchy_IDs[] = $row["hierarchy_ID"];
	
	// map our hierarchies from $hie_array into hierarchies from "views" table
	$found_hierarchy_IDs = array();
	
	foreach ($hie_array as $hie) // for each our selected hierarchy
	{
		// map to its parent in "views" table
		while (!in_array($hie, $all_hierarchy_IDs, TRUE))
			$hie = $hie_tree[$hie];
		$found_hierarchy_IDs[] = $hie;
	}

	$output = array();
	$output["data"] = array();
	$output["indicators"] = array();
	$output["ratings"] = array();

	// for each mapped hierarchy, select all relevant data, indicator and rating types
	$i = 0;
	foreach ($found_hierarchy_IDs as &$ID)
	{
		$i++;
		$ID = "'".$ID."'";
		
		$view_hierarchy_IDs_query_string = 
		"SELECT DISTINCT `type`, `value_type_ID` FROM `views` WHERE `hierarchy_ID` = ".$ID; // actual query string
		$view_hierarchy_IDs_query = mysqli_query($con, $view_hierarchy_IDs_query_string);
		
		// output found results into array
		while ($row = mysqli_fetch_array($view_hierarchy_IDs_query))
			$output[$row['type']][$i][] = $row['value_type_ID'];
	}
	
	// since results are stored in numerical order, not as associative array (for better manipulation in other functions), we need to store ID of each found hierarchy
	// not as a key for another dimension in associative array, but as a zero element in numerical array
	$found_hierarchy_IDs_string = implode(", ", $found_hierarchy_IDs);
	$view_hierarchy_IDs_query_string = 
	"SELECT DISTINCT `type`, `value_type_ID` FROM `views` WHERE `hierarchy_ID` IN (".$found_hierarchy_IDs_string.")";
	
	$view_hierarchy_IDs_query = mysqli_query($con, $view_hierarchy_IDs_query_string);
	while ($row = mysqli_fetch_array($view_hierarchy_IDs_query))
		$output[$row['type']][0][] = $row['value_type_ID'];
		
	return $output;
}

// get specification of selected columns
function get_specs($type, $value_IDs)
{
	// $type = 'ratings', 'indicators' or 'data'
	
	global $con, $data_specs, $indicators_specs, $ratings_specs;
	
	$output = array();	
	foreach ($value_IDs as $ID)
	{
		if ($type == 'data') $output[] = $data_specs[$ID];
		if ($type == 'indicators') $output[] = $indicators_specs[$ID];
		if ($type == 'ratings') $output[] = $ratings_specs[$ID];
	}
	
	return $output;
}

// function for determining existence (or non-existence) of values for selected rows
function get_existence($value_IDs)
{
	// $value_IDs - twodimensional array, first dimension is row number, second dimension is list of present rows
	// $value_IDs[0] - list of 'relevant' rows
	// $value_IDs[1], $value_IDs[2], ... - list of rows for each object (based on its hierarchy)
	
	$obj_count = count($value_IDs) - 1; // number of objects (1 for "profile" page, n for "comparison" page)
	$rows = count($value_IDs[0]); // numer of all relevant rows
	$output = array();
	
	for ($i=1; $i<=$obj_count; $i++) // for each object
	{
		$output[$i-1] = array();
		$c = 0;
		foreach ($value_IDs[$i] as $value) // for each row of selected object
		{
			$output[$i-1][$c] = in_array($value, $value_IDs[0], TRUE); // if current row is present in set of 'relevant' rows
			$c++;
		}
	}
	
	return $output;
}

// get texts of disclaimers
function get_disclaimers($valuetype, $data)
{
	// $valuetype - ratings, indicators or data
	// $data - IDs of values
	// output - twodimensional array - first dimension is number, key for second dimension is ID of type (ID of rating, ID of indicator or ID of data), value for second dimension is text of disclaimer
	
	global $con, $objects;
	
	$disclaimers = array();
	$c = 0;
	foreach ($objects as $object)
	{
		$disclaimers[$c] = array();
		$current_data_col = $data[$c];
		
		// only entities may have disclaimer
		if (!is_entity($object))
		{
			if (count($current_data_col) > 0)
				$disclaimers[$c] = array_fill(0, count($current_data_col), NULL);
			else
				$disclaimers[$c] = NULL;
		}
		else
		{
			// 'implode' value IDs for current object into string - for query purposes
			$string = '';
			foreach ($current_data_col as $type => $ID)
				$string .= "'".$ID."',";
			$string = substr($string, 0, -1);
			if ($string == '') $string = "''";
			
			$discls_array = array();		
			
			// query for selecting disclaimers based on type and list of value IDs
			$discls_query = mysqli_query($con, "SELECT * FROM `disclaimers` WHERE `value_type` = '".$valuetype."' AND `value_ID` IN (".$string.") AND `visibility` = 1");
			while ($row = mysqli_fetch_array($discls_query))
			{
				// write found disclaimers into array of disclaimers
				$key = array_search($row["value_ID"], $current_data_col, TRUE);
				if ($key !== FALSE)
					$discls_array[$key] = $row["text"];
			}
			
			// since previous array has stored only values that have disclaimers but we need info about disclaimer for every value, iterate through all values
			foreach ($current_data_col as $type => $ID)
			{
				if (isset($discls_array[$type]))
					$current_data_col[$type] = $discls_array[$type];
				else
					$current_data_col[$type] = NULL;
			}
			
			// add information on disclaimers for all values of current entity to final array
			$disclaimers[$c] = $current_data_col;
		}
		
		$c++;
	}
	
	return $disclaimers;
}

?>