<?php
	require_once('include/connection.php'); // mysql connection
	require_once('include/preload.php'); // texts and global settings

	require_once('include/tables.php'); // basic tables with data structure
	require_once('include/support.php'); // support functions
	require_once('include/format.php'); // formatting and displaying text and data
	require_once('include/taxonomy.php'); // operating with data and its structure
	require_once('include/values.php'); // getting values from tables
	require_once('include/ui.php'); // displaying values in profiles and rankings
	require_once('include/pages.php'); // dealing with text (non-data) pages
	
	require_once('structure/header.php');
	if ($GS["caching_enabled"])
		require_once('structure/caching-header.php'); // all content generated after main menu can be cached and generated from cache

?>

<?php
	// calculate 'special variables' - number of all values, all entities and all yeras available
	$entities_count_query = mysqli_query($con, "SELECT COUNT(*) AS count FROM `entities` WHERE 1");
	$entities_count_row = mysqli_fetch_array($entities_count_query);
	$entities_count = $entities_count_row["count"];
	
	$values_count_query_string = "
	SELECT 
	(SELECT COUNT(*) FROM `data` WHERE 1) AS `data_count`,
	(SELECT COUNT(*) FROM `indicators` WHERE 1) AS `indicators_count`,
	(SELECT COUNT(*) FROM `ratings` WHERE 1) AS `ratings_count`";
	$values_count_query = mysqli_query($con, $values_count_query_string);
	$values_count_row = mysqli_fetch_array($values_count_query);
	$values_count = $values_count_row["data_count"] + $values_count_row["indicators_count"] + $values_count_row["ratings_count"];
	
	$years_count = $GS["newest_year"] - $GS["oldest_year"] + 1;
	
?>

<div class="landing-wrapper">
	<img id="landing-img" src="/images/<?php echo $GS["landing_image"]; ?>"/>
  <div class="landing-text" style="color:<?php echo $GS["landing_text_color"]; ?>">
  
		<?php 
			// number of values and entities displaying with two valid digits (i.e., 1 234 567 will be displayed as 1 200 000)
			echo str_replace("[values_count]", number_format(round_down($values_count, 2), 0, $GS["decimal_separator"], $GS["thousand_separator"]), str_replace("[entities_count]", number_format(round_down($entities_count, 2), 0, $GS["decimal_separator"], $GS["thousand_separator"]), str_replace("[years_count]", $years_count, $T["l_main_text"]))); 
		?>
    
    <input name="main-search" type="text" id="main-search" onkeypress="if (event.keyCode == 13) doSearch('main-search');" placeholder="<?php echo $T['search_placeholder_text']; ?>"/><a name="main-submit" id="main-submit" type="submit" onclick="doSearch('main-search')"><img src="icons/loupe-white.png" width="19" height="19" /></a>
  </div>
</div>

<?php
	parse_display_string($GS["landing_layout"]);
?>

<?php
	require_once('structure/footer.php');

	if ($GS["caching_enabled"])
		require_once('structure/caching-footer.php');
?>