<?php
	// connection with database
	
	require_once('include/connection.php'); // mysql connection
	
	// creation of all tables with data, settings and texts
	
	$table_global_settings_query = "CREATE TABLE IF NOT EXISTS global_settings (
	`name` VARCHAR(100) PRIMARY KEY NOT NULL,
	`value` TEXT(65535),
	`explanation` TEXT(65535)
	)";

	$table_texts_query = "CREATE TABLE IF NOT EXISTS texts (
	`name` VARCHAR(100) PRIMARY KEY NOT NULL,
	`text` LONGTEXT,
	`explanation` TEXT(65535)
	)";
		
	$table_entity_properties_list_query = "CREATE TABLE IF NOT EXISTS entity_properties_list (
	`ID` VARCHAR(20) PRIMARY KEY NOT NULL,
	`name` VARCHAR(30),
	`text` TINYTEXT,
	`order` FLOAT,
	`datatype` VARCHAR(100)
	)";

	$table_entity_properties_query = "CREATE TABLE IF NOT EXISTS entity_properties (
	`ID` BIGINT PRIMARY KEY NOT NULL,
	`entity_ID` VARCHAR(20),
	`property_ID` VARCHAR(20),
	`value` VARCHAR(100)
	)";
	
	$table_entities_query = "CREATE TABLE IF NOT EXISTS entities (
	`ID` VARCHAR(20) PRIMARY KEY NOT NULL,
	`name` TINYTEXT,
	`sub_name` TINYTEXT,
	`short_name` TINYTEXT,
	`latitude` FLOAT,
	`longitude` FLOAT,
	`geography` VARCHAR(20),
	`hierarchy` VARCHAR(20),
	`disclaimer` TEXT(65535),
	`internal_note` TEXT(65535),
	`visibility` VARCHAR(1)
	)";
	
	$table_geographical_structure_list_query = "CREATE TABLE IF NOT EXISTS geographical_structure_list (
	`level` TINYINT(4) PRIMARY KEY NOT NULL,
	`name` VARCHAR(30),
	`text` TEXT(65535),
	`text_multi` TEXT(65535)
	)";
	
	$table_geographical_structure_query = "CREATE TABLE IF NOT EXISTS geographical_structure (
	`ID` VARCHAR(20) PRIMARY KEY NOT NULL,
	`level` TINYINT(4),
	`name` TEXT(65535),
	`short_name` TINYTEXT,
	`parent_ID` VARCHAR(20),
	`text_multi` TEXT(65535),
	`latitude` FLOAT,
	`longitude` FLOAT,
	`internal_note` TEXT(65535),
	`visibility` VARCHAR(1)
	)";
	
	$table_hierarchical_structure_list_query = "CREATE TABLE IF NOT EXISTS hierarchical_structure_list (
	`level` TINYINT(4) PRIMARY KEY NOT NULL,
	`name` VARCHAR(30),
	`text` TEXT(65535),
	`text_multi` TEXT(65535)
	)";
	
	$table_hierarchical_structure_query = "CREATE TABLE IF NOT EXISTS hierarchical_structure (
	`ID` VARCHAR(20) PRIMARY KEY NOT NULL,
	`level` TINYINT(4),
	`name` TEXT(65535),
	`short_name` TINYTEXT,
	`parent_ID` VARCHAR(20),
	`text_multi` TEXT(65535),
	`internal_note` TEXT(65535),
	`visibility` VARCHAR(1)
	)";
	
	$table_views_query = "CREATE TABLE IF NOT EXISTS views (
	ID INT PRIMARY KEY NOT NULL,
	type VARCHAR(30),
	hierarchy_ID VARCHAR(20),
	value_type_ID VARCHAR(20)
	)";
	
	$table_disclaimers_query = "CREATE TABLE IF NOT EXISTS disclaimers (
	`ID` BIGINT PRIMARY KEY NOT NULL,
	`value_ID` BIGINT,
	`value_type` VARCHAR(30),
	`text` TEXT(65535),
	`visibility` VARCHAR(1)
	)";
	
	$table_data_structure_query = "CREATE TABLE IF NOT EXISTS data_structure (
	`ID` VARCHAR(20) PRIMARY KEY NOT NULL,
	`level` TINYINT(4),
	`display_level` TINYINT(4),
	`name` TINYTEXT,
	`short_name` TINYTEXT,
	`parent_ID` VARCHAR(20),
	`order` FLOAT,
	`has_data` VARCHAR(1),
	`datatype` VARCHAR(100),
	`explanation` TEXT(65535),
	`disclaimer` TEXT(65535),
	`internal_note` TEXT(65535),
	`visibility` VARCHAR(1)
	)";

	$table_data_query = "CREATE TABLE IF NOT EXISTS data (
	`ID` BIGINT PRIMARY KEY NOT NULL,
	`year` FLOAT,
	`entity` VARCHAR(20),
	`type` VARCHAR(20),
	`value` TEXT(65535),
	`visibility` VARCHAR(1)
	)";
	
	$table_indicators_structure_query = "CREATE TABLE IF NOT EXISTS indicators_structure (
	`ID` VARCHAR(20) PRIMARY KEY NOT NULL,
	`level` TINYINT(4),
	`display_level` TINYINT(4),
	`name` TINYTEXT,
	`short_name` TINYTEXT,
	`parent_ID` VARCHAR(20),
	`order` FLOAT,
	`has_data` VARCHAR(1),
	`datatype` VARCHAR(100),
	`legend` TEXT(65535),
	`significance` VARCHAR(30),
	`min_rating` FLOAT,
	`max_rating` FLOAT,
	`rating_datatype` VARCHAR(100),
	`explanation` TEXT(65535),
	`disclaimer` TEXT(65535),
	`internal_note` TEXT(65535),
	`visibility` VARCHAR(1)
	)";
	
	$table_indicators_query = "CREATE TABLE IF NOT EXISTS indicators (
	`ID` BIGINT PRIMARY KEY NOT NULL,
	`year` FLOAT,
	`entity` VARCHAR(20),
	`type` VARCHAR(20),
	`value` TEXT(65535),
	`rating_value` DOUBLE,
	`weight` DOUBLE,
	`visibility` VARCHAR(1)
	)";
	
	$table_ratings_structure_query = "CREATE TABLE IF NOT EXISTS ratings_structure (
	`ID` VARCHAR(20) PRIMARY KEY NOT NULL,
	`level` TINYINT(4),
	`display_level` TINYINT(4),
	`name` TINYTEXT,
	`short_name` TINYTEXT,
	`parent_ID` VARCHAR(20),
	`order` FLOAT,
	`has_data` VARCHAR(1),
	`datatype` VARCHAR(100),
	`legend` TEXT(65535),
	`significance` VARCHAR(30),
	`minimum` FLOAT,
	`maximum` FLOAT,
	`explanation` TEXT(65535),
	`disclaimer` TEXT(65535),
	`internal_note` TEXT(65535),
	`visibility` VARCHAR(1)
	)";
	
	$table_ratings_query = "CREATE TABLE IF NOT EXISTS ratings (
	`ID` BIGINT PRIMARY KEY NOT NULL,
	`year` FLOAT,
	`entity` VARCHAR(20),
	`type` VARCHAR(20),
	`value` DOUBLE,
	`weight` DOUBLE,
	`visibility` VARCHAR(1)
	)";
	
	$created = 0;
	$errors	= 0;
	
	$table_queries = array(
		$table_global_settings_query,
		$table_texts_query,
		$table_entity_properties_list_query,
		$table_entity_properties_query,
		$table_entities_query,
		$table_geographical_structure_list_query,
		$table_geographical_structure_query,
		$table_hierarchical_structure_list_query,
		$table_hierarchical_structure_query,
		$table_views_query,
		$table_disclaimers_query,
		$table_data_structure_query,
		$table_data_query,
		$table_indicators_structure_query,
		$table_indicators_query,
		$table_ratings_structure_query,
		$table_ratings_query
	);
	
	$table_names = array(
		"global_settings",
		"texts",
		"entity_properties_list",
		"entity_properties",
		"entities",
		"geographical_structure_list",
		"geographical_structure",
		"hierarchical_structure_list",
		"hierarchical_structure",
		"views",
		"disclaimers",
		"data_structure",
		"data",
		"indicators_structure",
		"indicators",
		"ratings_structure",
		"ratings"
	);
	
	$table_count = count($table_queries);
	
	for ($i=0; $i<$table_count; $i++)
	{
		if (mysqli_query($con, $table_queries[$i])) 
		{
			$created++;
			echo "Table '".$table_names[$i]."' created successfully.<br />";
		} 
		else 
		{
			$errors++;
			echo "Error creating table '".$table_names[$i]."': " . mysqli_error($conn) . ".<br />";
		}		
	}
	
	echo "<br /><strong>Created ".$created." of ".($created + $errors)." tables.<br />";
	
	if ($errors == 0) 
	{
		echo "All tables created successfully.";
		unlink(__FILE__);
	}
	else
		echo "Some error(s) occured.";
		
	echo "</strong>";
		
	mysqli_close($con);
?>