<?php

	// caching settings
	$cache_ext = '.html'; // file extension
	$cache_time = $GS["cache_duration"];  // cache file expires afere these seconds
	$cache_folder = '_cache/'; // folder to store cache files
	$ignore_pages = array('', '');
	
	$dynamic_url = 'http://'.$_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] . $_SERVER['QUERY_STRING']; // requested dynamic page (full url)

	$md5_file = md5($dynamic_url); // converts url to md5 hash
	$md5_parts = str_split($md5_file, 8); // split url into 8-character long chunks
	// instead of one 32-char long name, names will be stored in directory structure for better performance and to avoid limitation issues
	// if no directory structure is provided, all cache files would be stored in the same directory - what will soon reach limit of maximum number of files in the same directory
	// for example, if there are 1 000 000 cached files and directory structure has three levels, each directory would contain on average 100 files. 
	$md5_path = $md5_parts[0].'/'.$md5_parts[1].'/'.$md5_parts[2].'/'.$md5_parts[3]; 
	$cache_file = $cache_folder.$md5_path.$cache_ext; // construct a cache file
	
	$ignore = (in_array($dynamic_url,$ignore_pages))?true:false; //check if url is in ignore list
	
	if (!$ignore && file_exists($cache_file) && time() - $cache_time < filemtime($cache_file)) //check if cache exist and it's not expired
	{ 
		if (isset($con)) mysqli_close($con); // close opened connection, since footer that normally closes it does not load
		ob_start(); // turn on output buffering
		readfile($cache_file); // read cache file
		echo '<!-- cached page - '.date('l jS \of F Y h:i:s A', filemtime($cache_file)).' -->';
		ob_end_flush(); // flush and turn off output buffering
		exit(); // no need to proceed further, exit the flow
	}
	// turn on output buffering
	ob_start();

?>
